package extThopt;

import javax.swing.*;
import java.awt.*;

public class SettingsFrame extends JFrame
{
    TechnoExch te;
    FlowConfig fc;
	
	
	public SettingsFrame(){
		//{{INIT_CONTROLS
		setTitle("License");
		getContentPane().setLayout(null);
		setSize(780,459);
		setVisible(false);
		JLabel5.setText("C1 (Nu)");
		getContentPane().add(JLabel5);
		JLabel5.setBounds(12,108,144,20);
		d_value.setText("-0.25");
		getContentPane().add(d_value);
		d_value.setBounds(156,288,120,20);
		C1_value.setText("0.33");
		getContentPane().add(C1_value);
		C1_value.setBounds(156,108,120,20);
		JLabel4.setText("a (Re)");
		getContentPane().add(JLabel4);
		JLabel4.setBounds(12,132,144,20);
		Re_value.setText("0.6");
		getContentPane().add(Re_value);
		Re_value.setBounds(156,132,120,20);
		JLabel6.setText("b (Pr)");
		getContentPane().add(JLabel6);
		JLabel6.setBounds(12,156,144,20);
		Pr_value.setText("0.33");
		getContentPane().add(Pr_value);
		Pr_value.setBounds(156,156,120,20);
		JLabel8.setText("c (viscosity)");
		getContentPane().add(JLabel8);
		JLabel8.setBounds(12,180,144,20);
		Viscosity_value.setText("0.14");
		getContentPane().add(Viscosity_value);
		Viscosity_value.setBounds(156,180,120,20);
		JLabel9.setText("C2 (f)");
		getContentPane().add(JLabel9);
		JLabel9.setBounds(12,264,144,20);
		C2_value.setText("0.316");
		getContentPane().add(C2_value);
		C2_value.setBounds(156,264,120,20);
		JLabel3.setText("d (Re)");
		getContentPane().add(JLabel3);
		JLabel3.setBounds(12,288,132,20);
		correlLabel.setText("Colburn correlation");
		getContentPane().add(correlLabel);
		correlLabel.setForeground(java.awt.Color.red);
		correlLabel.setBounds(12,24,750,36);
		JLabel1.setText("Nusselt correlation");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(12,72,252,24);
		JLabel2.setText("f correlation");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(12,228,252,24);
		okButton.setText("Save settings");
		okButton.setActionCommand("OK");
		getContentPane().add(okButton);
		okButton.setBounds(312,372,168,36);
		JCheckColebrook.setText("Colebrook equation");
		JCheckColebrook.setActionCommand("internal settings");
		getContentPane().add(JCheckColebrook);
		JCheckColebrook.setBounds(228,228,152,24);
		bCancel.setText("Cancel");
		bCancel.setActionCommand("Cancel");
		getContentPane().add(bCancel);
		bCancel.setBounds(528,372,84,36);
		bLoad.setText("Load settings");
		bLoad.setActionCommand("Load settings");
		getContentPane().add(bLoad);
		bLoad.setBounds(48,372,144,36);
		JLabel7.setText("Nu laminar");
		getContentPane().add(JLabel7);
		JLabel7.setBounds(324,108,144,20);
		laminarNu_value.setText("7");
		getContentPane().add(laminarNu_value);
		laminarNu_value.setBounds(468,108,120,20);
		JCheckLaminar.setText("laminar flow");
		JCheckLaminar.setActionCommand("internal settings");
		getContentPane().add(JCheckLaminar);
		JCheckLaminar.setBounds(324,156,132,24);
		JLabel10.setText("Relative roughness");
		getContentPane().add(JLabel10);
		JLabel10.setBounds(312,276,144,20);
		RR_value.setText("0.001");
		getContentPane().add(RR_value);
		RR_value.setBounds(456,276,120,20);
		Kh_value.setText("Kh (void fraction)");
		getContentPane().add(Kh_value);
		Kh_value.setBounds(312,336,144,20);
		JTextField1.setText("1");
		getContentPane().add(JTextField1);
		JTextField1.setBounds(456,336,120,20);
		getContentPane().add(pdcCorrelChoice);
		JLabel11.setText("Two phase correlation");
		getContentPane().add(JLabel11);
		JLabel11.setBounds(412,220,168,20);

		pdcCorrelChoice.setBounds(412,240,168,24);
		
        pdcCorrelChoice.addItem("Sun & Mishima");
        pdcCorrelChoice.addItem("Mller-Steinhagen & Heck");
        pdcCorrelChoice.addItem("Friedel");
        pdcCorrelChoice.addItem("Lockhart-Martinelli");
        pdcCorrelChoice.addItem("Herer");
        pdcCorrelChoice.addItem("");
		
		
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymItem lSymItem = new SymItem();
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		bCancel.addActionListener(lSymAction);
		bLoad.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		setTitle("Correlation parameter settings");
	}

	public SettingsFrame(TechnoExch te){
	    this();
        this.te=te;
        fc=te.fc;
		C1_value.setText(Util.aff_d(fc.C1,5));
		Re_value.setText(Util.aff_d(fc.a_Re,5));
		Pr_value.setText(Util.aff_d(fc.b_Pr,5));
		Viscosity_value.setText(Util.aff_d(fc.c_Visc,5));
		laminarNu_value.setText(Util.aff_d(fc.NuLamin,5));
		C2_value.setText(Util.aff_d(fc.C2,5));
		d_value.setText(Util.aff_d(fc.d_Re,5));
		RR_value.setText(Util.aff_d(fc.RR,7));
		JCheckLaminar.setSelected(fc.laminar);
		JCheckColebrook.setSelected(fc.colebrook);
		
    }
    public void setFlowConfig(FlowConfig fc){
        this.fc=fc;
    }
    public void maskPdcCorrel(){
		getContentPane().remove(pdcCorrelChoice);
		getContentPane().remove(JLabel11);
    }
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == SettingsFrame.this)
			SettingsFrame_WindowClosing(event);
		}
	}

	void SettingsFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField d_value = new javax.swing.JTextField();
	javax.swing.JTextField C1_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Re_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField Pr_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JTextField Viscosity_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JTextField C2_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JLabel correlLabel = new javax.swing.JLabel();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JButton okButton = new javax.swing.JButton();
	javax.swing.JCheckBox JCheckColebrook = new javax.swing.JCheckBox();
	javax.swing.JButton bCancel = new javax.swing.JButton();
	javax.swing.JButton bLoad = new javax.swing.JButton();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField laminarNu_value = new javax.swing.JTextField();
	javax.swing.JCheckBox JCheckLaminar = new javax.swing.JCheckBox();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JTextField RR_value = new javax.swing.JTextField();
	javax.swing.JLabel Kh_value = new javax.swing.JLabel();
	javax.swing.JTextField JTextField1 = new javax.swing.JTextField();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JComboBox pdcCorrelChoice= new javax.swing.JComboBox();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_actionPerformed(event);
			else if (object == bCancel)
				bCancel_actionPerformed(event);
			else if (object == bLoad)
				bLoad_actionPerformed(event);
		}
	}

	void okButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		init();
		/*
		fc.C1=Util.lit_d(C1_value.getText());
		fc.a_Re=Util.lit_d(Re_value.getText());
		fc.b_Pr=Util.lit_d(Pr_value.getText());
		fc.c_Visc=Util.lit_d(Viscosity_value.getText());
		fc.NuLamin=Util.lit_d(laminarNu_value.getText());
		fc.C2=Util.lit_d(C2_value.getText());
		fc.d_Re=Util.lit_d(d_value.getText());
		fc.RR=Util.lit_d(RR_value.getText());
		fc.laminar=JCheckLaminar.isSelected();
		fc.colebrook=JCheckColebrook.isSelected();
		fc.Kh=Util.lit_d(Kh_value.getText());*/
	}
	
	void init(){
		fc.C1=Util.lit_d(C1_value.getText());
		fc.a_Re=Util.lit_d(Re_value.getText());
		fc.b_Pr=Util.lit_d(Pr_value.getText());
		fc.c_Visc=Util.lit_d(Viscosity_value.getText());
		fc.NuLamin=Util.lit_d(laminarNu_value.getText());
		fc.C2=Util.lit_d(C2_value.getText());
		fc.d_Re=Util.lit_d(d_value.getText());
		fc.RR=Util.lit_d(RR_value.getText());
		fc.laminar=JCheckLaminar.isSelected();
		fc.colebrook=JCheckColebrook.isSelected();
		fc.Kh=Util.lit_d(Kh_value.getText());
		fc.pdcCorrel=(String)pdcCorrelChoice.getSelectedItem();  
		
	}

	void bCancel_actionPerformed(java.awt.event.ActionEvent event)
	{
		dispose();
	}

	void bLoad_actionPerformed(java.awt.event.ActionEvent event)
	{
	    loadSettings();
	}
	void loadSettings(){
		C1_value.setText(Util.aff_d(fc.C1,5));
		Re_value.setText(Util.aff_d(fc.a_Re,5));
		Pr_value.setText(Util.aff_d(fc.b_Pr,5));
		Viscosity_value.setText(Util.aff_d(fc.c_Visc,5));
		laminarNu_value.setText(Util.aff_d(fc.NuLamin,5));
		C2_value.setText(Util.aff_d(fc.C2,5));
		d_value.setText(Util.aff_d(fc.d_Re,5));
		RR_value.setText(Util.aff_d(fc.RR,7));
		Kh_value.setText(Util.aff_d(fc.Kh,2));
		JCheckLaminar.setSelected(fc.laminar);
		JCheckColebrook.setSelected(fc.colebrook);
		pdcCorrelChoice.setSelectedItem(fc.pdcCorrel);  
			 
	}
}