/*
Copyright Renaud GICQUEL 2005-2006  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.*; 
import javax.swing.*;

/**
 * Classe correspondant  un modle de diffuseur
 * Il y a deux moyens de calculer le composant : 
 *      - soit dterminer la pression de sortie connaissant la vitesse des gaz  l'entre
 *      - soit dterminer la vitesse des gaz en sortie connaissant la pression  l'entre
 * 
 * Le rendement isentropique est entr en paramtre dans le champ eta_s_value
 *
 * La vitesse des gaz  l'entre est entre en paramtre dans le champ Cin_value
 *
 * La vitesse des gaz en sortie est affiche dans le champ Cout_value
 * La pression de sortie est affiche dans le champ pOut_value
 * Le nombre de Mach  l'entre est affich dans le champ Ma_value
 * 
 * @author Renaud GICQUEL
 */
public class Diffuser extends ExtProcess 
{
    
	final ButtonGroup groupSystemType=new ButtonGroup();
	javax.swing.JRadioButton calcP = new javax.swing.JRadioButton();
	javax.swing.JRadioButton calcC = new javax.swing.JRadioButton();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField pOut_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField Ma_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField eta_s_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField cIn_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField cOut_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField outSection_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField minSection_value = new javax.swing.JTextField();
    
    double  P, Cin,Cout, outSection, minSection, Ma,eta_s;
    double Tamont, Taval, Pamont, Paval;
    double Hamont,Samont;
    double flow;
    
    public Diffuser (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,400,300);
		JLabel1.setText("outlet pressure (bar)");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,90,164,24);
		JPanel1.add(pOut_value);
		pOut_value.setBounds(164,90,124,24);
		pOut_value.setText("0.8");
		JPanel1.add(calcP);
		calcP.setBounds(164,200,200,24);
		calcP.setText("Calculate outlet pressure");
		JPanel1.add(calcC);
		calcC.setBounds(164,230,200,24);
		calcC.setText("Calculate outlet velocity");
		JLabel2.setText("Mach number");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,60,164,24);
		JPanel1.add(Ma_value);
		Ma_value.setBounds(164,60,124,24);
		Ma_value.setText("0");
		JLabel4.setText("inlet velocity (m/s)");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,0,164,24);
		JPanel1.add(cIn_value);
		cIn_value.setBounds(164,0,124,24);
		cIn_value.setText("10");
		JLabel3.setText("isentropic efficiency");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,30,164,24);
		JPanel1.add(eta_s_value);
		eta_s_value.setBounds(164,30,124,24);
		eta_s_value.setText("1");
		JLabel5.setText("outlet velocity (m/s)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,120,164,24);
		JPanel1.add(cOut_value);
		cOut_value.setBounds(164,120,124,24);
		cOut_value.setText("10");
		type=getType();
   		thermoCouplerTypes=new String[0];//no thermocoupler connected
	    groupSystemType.add(calcP);
	    groupSystemType.add(calcC);
 }
    
    public String getType(){
        return "diffuser";
    }
	public String getClassDescription(){
	    return "adiabatic diffuser model\n\nauthor : R. Gicquel april 2006\n\nRef : archive Diffuser.zip";
	}
    
    public String getName(){
        return tfe.getCompName();
    }
    public double getFlow(){
        return flow;
    }
    public double getInletVelocity(){
        return Cin;
    }
    public void setInletVelocity(double C){
        Cin=C;
	    cIn_value.setText(Util.aff_d(Cin,2));
    }
    public void setAmbientConditions(double Text, double Pext){
	    Tpoint=Text;
	    Ppoint=Pext;
        tfe.setupPointAmont(getProperties());
    }
    
	public double getSpeed(double Ma, double Text, double Pext){
        String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
        getPointProperties(amont);//direct parsing of point property vector
	    lecorps.CalcPropCorps(Text+1,Pext, 1);  
        getSubstProperties(nomCorps);
	    double H1=Hsubst;
	    lecorps.CalcPropCorps(Text,Pext, 1);
        getSubstProperties(nomCorps);
	    double Cp=H1-Hsubst;
	    double r=8.314/Msubst;
	    double gamma=Cp/(Cp-r);
	    double Cs=Math.pow(gamma*r*Text*1000, 0.5);
	    return Ma*Cs;
	}
    
	public void calculateProcess(){
        String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        flow=f.doubleValue();
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
        getPointProperties(amont);//direct parsing of point property vector
        Tamont=Tpoint;
        Pamont=Ppoint;
        Hamont=Hpoint;
        Samont=Spoint;

        //chargement des valeurs affiches  l'cran 
        P=Util.lit_d(pOut_value.getText());
        Cin=Util.lit_d(cIn_value.getText());
        Cout=Util.lit_d(cOut_value.getText());
        eta_s=Util.lit_d(eta_s_value.getText());
        
        double HtotAmont=Hamont+Cin*Cin/2000;//enthalpie totale amont
        //estimation du Cp amont (on fait les calculs avec l'hypothse d'un gaz parfait pour ce Cp)
	    lecorps.CalcPropCorps(Tamont,Pamont, 1);//this method recalculates the substance properties 
        getSubstProperties(nomCorps);
        double H1=Hsubst;
	    lecorps.CalcPropCorps(Tamont+1,Pamont, 1);
        getSubstProperties(nomCorps);
        double Cp=Hsubst-H1;
  	    double r=8.314/Msubst;
	    double gamma=Cp/(Cp-r);
	    
	    double Cs=Math.pow(gamma*r*Tamont*1000, 0.5);//vitesse du son
	    Ma=Cin/Cs;//nombre de Mach
		Ma_value.setText(Util.aff_d(Ma,3));
  
        if(calcP.isSelected()){//calcul de la pression de sortie
            double Haval=HtotAmont-Cout*Cout/2000;
		    double DTref=(gamma-1)/2.*(Ma*Ma-Cout*Cout/Cs/Cs);
            double beta=gamma/(gamma-1);
            Paval=Pamont*Math.pow(1.+eta_s*DTref, beta);//pression statique du point B (quation 4 de la notice)
            double Tb=lecorps.getT_from_sP(Samont,Paval);//temprature du point B
	        lecorps.CalcPropCorps(Tb,Paval, 1);
            getSubstProperties(nomCorps);
            double Hrs=Hsubst;//enthalpie du point B
            double H=(Hrs-Hamont)/eta_s+Hamont;//enthalpie du point R
            Taval=lecorps.getT_from_hP(H,Paval);//temprature du point R
	        pOut_value.setText(Util.aff_d(Paval,5));
            
        }
        else{
            double Trs=lecorps.getT_from_sP(Samont,P);//inversion en T de la fonction entropie (temprature de stagnation isentropique)
	        lecorps.CalcPropCorps(Trs,P, 1);
            getSubstProperties(nomCorps);
            double Hrs=Hsubst;
            double H=(Hrs-Hamont)/eta_s+Hamont;
            Taval=lecorps.getT_from_hP(H,P);
	        lecorps.CalcPropCorps(Taval,P, 1);
            getSubstProperties(nomCorps);
   /*         double eta_p=(1+(gamma-1)/2*Ma*Ma)*Math.pow(eta_s,(gamma-1)/gamma)-1;
            eta_p=eta_p/(gamma-1)*2./Ma/Ma;
      //      double Haval=Hsubst-Cout*Cout/2000;//enthalpie aval*/
            System.out.println("HtotAmont : "+HtotAmont+"  Hsubst : "+Hsubst);
            double x=2000.*(HtotAmont-Hsubst)*eta_s;
            if(x<0)x=0;
            Cout=Math.pow(x, 0.5);//vitesse de sortie
	        cOut_value.setText(Util.aff_d(Cout,2));
	        Paval=P;	        
        }
        //mise  jour du point aval
	    Tpoint=Taval;
	    Ppoint=Paval;
        tfe.setupPointAval(getProperties());
	    
	}
	
    
	public void readCompParameters(String ligne_data){
		P=Util.lit_d(Util.extr_value(ligne_data, "pOut_value"));
		Cin=Util.lit_d(Util.extr_value(ligne_data, "cIn_value"));
	    pOut_value.setText(Util.aff_d(P,5));
	    cIn_value.setText(Util.aff_d(Cin,2));
	    calcP.setSelected(Util.lit_b(Util.extr_value(ligne_data, "calcP_value")));
	    calcC.setSelected(Util.lit_b(Util.extr_value(ligne_data, "calcC_value")));
		Cout=Util.lit_d(Util.extr_value(ligne_data, "cOut_value"));
	    cOut_value.setText(Util.aff_d(Cout,2));
		eta_s=Util.lit_d(Util.extr_value(ligne_data, "eta_s_value"));
	    eta_s_value.setText(Util.aff_d(eta_s,4));
	}
	
    public String saveCompParameters(){
	    String h="pOut_value="+pOut_value.getText()+tab
	    +"cIn_value="+cIn_value.getText()+tab
	    +"calcP_value="+Util.aff_b(calcP.isSelected()) +tab
	    +"calcC_value="+Util.aff_b(calcC.isSelected()) +tab
	    +"cOut_value="+cOut_value.getText()+tab
	    +"eta_s_value="+eta_s_value.getText()+tab
	    ;
        return h;
    }
 

}