/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.Vector;


public class EvapPlateConfigGungorW extends FlowConfig 
{
	double Bo;//nombre d'bullition
     public EvapPlateConfigGungorW (){
    }

    public String getCode(){
        return "evap_plate";
    }
	public String getClassDescription(){
	    return "Gungor Winterton plate correlation";
	}
  
    public EvapPlateConfigGungorW (TechnoExch te){
        super(te);
        NuCorrel="evap_plate";
    }
 /*   void setParameterValues(){//modRG 07/2012
        C1=0.022;a_Re=0.79;b_Pr=0.39;c_Visc=0.14;RR=0.001;
        C2=0.31;d_Re=-0.25;    	
    }*/

        
	public double calcNu(double P){
	    if(te.diph){//calcul de Ulv
	    	double xinit=te.amont.X;
	        double Tsat=te.corps.lecorps.getSatTemperature(P,0);
	        double Psat=te.corps.lecorps.getSatPressure(Tsat, 0);
	        te.corps.lecorps.CalcPropCorps(Tsat-0.1, Psat, 0);
	        te.corps.getSubstProperties();
	        double Vl=te.corps.V;
	        Tsat=te.corps.lecorps.getSatTemperature(P,1);
	        Psat=te.corps.lecorps.getSatPressure(Tsat, 1);
	        te.corps.lecorps.CalcPropCorps(Tsat+0.1, Psat, 1);
	        te.corps.getSubstProperties();
	        double Vv=te.corps.V;
	        double fact=Vv/Vl;
	  //  	System.out.println("Vv diph "+Vv+"  Vl "+Vl);
	    	
	 //   	te.aval.getProperties();
	  //  	te.amont.getProperties();
	       //il y a un problme pour les corps externes sur X
	        if(te.corps.lecorps.isMixture) {
		    //	System.out.println("te.aval.X "+te.aval.X+"  xinit "+xinit);
		    //	System.out.println("te.aval.X0 "+te.aval.lecorps.getQuality()[0]+"  te.amont.X0 "+te.amont.lecorps.getQuality()[0]);
		    //	System.out.println("te.aval.corps.X "+te.aval.corps.X+"  te.amont.corps.X "+te.amont.corps.X);
	        	Nu=calcNu(te.aval.X,te.amont.corps.X,fact);//nombre de Nsselt
	        }
	        else  {
		 //   	System.out.println("te.aval.X "+te.aval.X+"  te.amont.X "+te.amont.X);
	        	Nu=calcNu(te.aval.X,te.amont.X,fact);//nombre de Nsselt
	        }
	    //	System.out.println("evapConfig Nu diph "+Nu);
	   // 	System.out.println("Re diph "+te.getRe()+"  Pr "+te.getPr());

	        //prise en compte du taux de vide pour le calcul de la charge en frigorigne
	        calcMeanDensity(Vl, Vv, te.aval.X, te.amont.X);
	    }
	    else Nu=calcNuTube();
	    
	    return Nu;
	}
	
    private double calcNu(double xs, double xe, double fact){//nombre de Nsselt pour un tube
        //xs est le titre de sortie
        //xe est le titre d'entre
        //fact est un paramtre (Vv/Vl pour l'vaporation, PC/Pcond pour la condensation)
        
        // corrlation de Gungor et Winterton
    //     System.out.println("Bo : "+Bo);
        double Fs= -0.0079*xs*xs*xs*xs - 0.131*xs*xs*xs + 0.6128*xs*xs + 0.0651*xs - 0.0054;
        double Fe= -0.0079*xe*xe*xe*xe - 0.131*xe*xe*xe + 0.6128*xe*xe + 0.0651*xe - 0.0054;
        double F=1.12*(Fs-Fe)/(xs-xe);
        Fs=-1/1.8*Math.pow(1-xs,1.8);
        Fe=-1/1.8*Math.pow(1-xe,1.8);
        double F2=(Fs-Fe)/(xs-xe);
        
        double T=te.corps.lecorps.getSatTemperature(te.aval.P, 0);
        te.corps.getSubstProperties();
	    te.corps.lecorps.CalcPropCorps(T+0.1,te.aval.P,0);
 	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
        double ro_v=1/v;
        f=(Double)vProp.elementAt(5);
        double hv=f.doubleValue();
         T=te.corps.lecorps.getSatTemperature(te.amont.P, 0);
 	    te.corps.lecorps.CalcPropCorps(T-0.1,te.amont.P,0);
	    vProp=te.corps.lecorps.getSubstProperties();
        f=(Double)vProp.elementAt(3);
        v=f.doubleValue();
        double ro_l=1/v;
        te.corps.getSubstProperties();
        f=(Double)vProp.elementAt(5);
        double hl=f.doubleValue();
        double Lv=(hv-hl)*1000.;//Latent heat in J/kg
        
        
        if(te.tHx.firstIteration)//On utilise cette formule simplifie avant tout calcul
        Bo=Util.lit_d(te.Dh_value.getText())/4./Util.lit_d(te.L_value.getText());
        else Bo=te.tHx.qlv/te.getFlow()*Util.lit_d(te.Ac_value.getText())/Lv;
        System.out.println("Bo EvapPlate Gungor : "+Bo);
   
  //      System.out.println("EvapConfig "+te.corps.name+ " T : "+T+ " P : "+te.amont.P+T+ " x : "+te.amont.X);
   // 	System.out.println("Re diph 1 "+te.getRe()+"  Pr "+te.getPr());

	    te.initLambdaMu(T-0.1,te.amont.P, 0);
        
	    if(false){//si prise en compte laminaire
            double Nu=0;
	        double Nut=C1*Math.pow(turbulentLimit,a_Re)*Math.pow(te.getPr(),b_Pr);
	        double Nul=getNuLamin();
	        double Re=te.getRe();
	        if(Re<=laminarLimit)Nu=Nul;
	        else if(Re>=turbulentLimit)Nu=C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
	        else{
	            double alpha=(Re-laminarLimit)/(turbulentLimit-laminarLimit);
	            Nu=Nul+(Nut-Nul)*alpha;
	        }
	        
            return Nu*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
        }
        else {
	        double Fact=(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
	 //       System.out.println("Fact "+Fact);
	        //attention : on multiplie Re par (1-x) car dans la corrlation de Gungor et Winterton 
	        //le calcul de Nuliq doit tre fait avec le dbit de la phase liquide seule 
	        if(te.corps.lecorps.isMixture) {
        		te.amont.X=te.amont.corps.X;
	        }
	        double Nut_lo=C1*Math.pow(te.getRe()*(1.-te.amont.X),a_Re)*Math.pow(te.getPr(),b_Pr);
	        
	        double gWNut_av=Nut_lo*Fact;
//            return C1*Math.pow(te.getRe()*(1.-te.amont.X),a_Re)*Math.pow(te.getPr(),b_Pr)*Fact;

	        //Borishanskij et al. Correlation
	        double q_wall=Bo*te.getFlow()/Util.lit_d(te.Ac_value.getText())*Lv;
	        double h_pb=0.625*(Math.pow(te.amont.P*1e5,0.14)+8.95e-14*te.amont.P*1e5*te.amont.P*1e5)
	        		*Math.pow(q_wall,0.7);
			System.out.println("gungorWinterton moyen\t"+gWNut_av+"\tq_wall\t"+q_wall);
//			System.out.println("q_wall\t"+q_wall+"\th_lo\t"+h_lo+"\th_pb\t"+h_pb+"\tL\t"+Lv);
			System.out.println("Bo\t"+Bo+"\tro_l\t"+ro_l+"\tro_v\t"+ro_v+"\tL\t"+Lv);
			double NUT=0;
			double gWNut=0;
			for(int i=1;i<100;i++){
				double x=i/100.;			
		        Nut_lo=C1*Math.pow(te.getRe()*(1.-x),a_Re)*Math.pow(te.getPr(),b_Pr);
		        double h_lo=Nut_lo/Util.lit_d(te.Dh_value.getText())*te.lambda;
				
				Fact=1+3000*Math.pow(Bo,0.86)+1.12*Math.pow(x/(1-x), 0.75)*Math.pow(ro_l/ro_v, 0.41);
				gWNut=gWNut+Nut_lo*Fact/99.;
				
		        double h_2=(h_lo*h_lo+0.49*h_pb*h_pb)*
		        		(1+7e-9*h_pb*h_pb/(h_lo*h_lo+0.49*h_pb*h_pb)*
		        		Math.pow(1+x*(ro_l/ro_v-1),1.5)*Math.pow(Bo,-1.5));
		        double h=Math.pow(h_2,0.5);
		        NUT=NUT+h*Util.lit_d(te.Dh_value.getText())/te.lambda/99.;
				//System.out.println("Borishanskij NUT\t"+NUT+"\th\t"+h+"\tgWNut\t"+gWNut+"\tx\t"+x);
		
			}
	        
			System.out.println("Borishanskij NUT\t"+NUT+"\tgWNut\t"+gWNut);
	        
	        return gWNut;
//	        return NUT;
        }
 //       else return 0.023*Math.pow(te.getRe(), 0.8)*Math.pow(te.getPr(), 0.4)*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
 //      return calcNuTube()*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
    }

	public double calcDP(){
	    return calcDPdiff();
	}

	public double getPressFactor(){
	    return Util.lit_d(te.display_value.getText());
    }

	public void setPressFactor(double fact){
	    te.display_value.setText(Util.aff_d(fact));
    }
	
	/**
	 * reads specific technoDesign parameters
	 */
	public void readCaract(String ligne_data){
	    super.readCaract(ligne_data);
        String valeur;
        valeur=Util.extr_value2(ligne_data, "pressure_factor");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.display_value.setText(valeur);
        }
        valeur=Util.extr_value2(ligne_data, "flux density");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.tHx.qlv=value;
            te.tHx.firstIteration=false;
        }
	}

	/**
	 * saves specific technoDesign parameters
	 */
    public String saveCaract(){
	    String h=super.saveCaract();
        h=h+"pressure_factor="+te.display_value.getText()+":"
        		+"flux density="+Util.aff_d(te.tHx.qlv);
        ;
        return h;
    }
	

	

}