/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.Vector;


public class EvapPlateForsterG extends FlowConfig 
{
     public EvapPlateForsterG (){
    }

    public String getCode(){
        return "Forster Geist";
    }
	public String getClassDescription(){
	    return "Forster Geist correlation";
	}
  
    public EvapPlateForsterG (TechnoExch te){
        super(te);
        NuCorrel="evap boiling";
    }

        
	public double calcNu(double P){
	    if(te.diph){//calcul de Ulv
	    	double xinit=te.amont.X;
	        double Tsat=te.corps.lecorps.getSatTemperature(P,0);
	        double Psat=te.corps.lecorps.getSatPressure(Tsat, 0);
	        te.corps.lecorps.CalcPropCorps(Tsat-0.1, Psat, 0);
	        te.corps.getSubstProperties();
	        double Vl=te.corps.V;
	        Tsat=te.corps.lecorps.getSatTemperature(P,1);
	        Psat=te.corps.lecorps.getSatPressure(Tsat, 1);
	        te.corps.lecorps.CalcPropCorps(Tsat+0.1, Psat, 1);
	        te.corps.getSubstProperties();
	        double Vv=te.corps.V;
	        double fact=Vv/Vl;
	       //il y a un problme pour les corps externes sur X
	        if(te.corps.lecorps.isMixture) {
		    //	System.out.println("te.aval.X "+te.aval.X+"  xinit "+xinit);
		    //	System.out.println("te.aval.X0 "+te.aval.lecorps.getQuality()[0]+"  te.amont.X0 "+te.amont.lecorps.getQuality()[0]);
		    //	System.out.println("te.aval.corps.X "+te.aval.corps.X+"  te.amont.corps.X "+te.amont.corps.X);
	        	Nu=calcNu(te.aval.X,te.amont.corps.X,fact);//nombre de Nsselt
	        }
	        else  {
		 //   	System.out.println("te.aval.X "+te.aval.X+"  te.amont.X "+te.amont.X);
	        	Nu=calcNu(te.aval.X,te.amont.X,fact);//nombre de Nsselt

	        }
	        //prise en compte du taux de vide pour le calcul de la charge en frigorigne
	        calcMeanDensity(Vl, Vv, te.aval.X, te.amont.X);
	    }
	    else Nu=calcNuTube();
	    
	    return Nu;
	}
	
    private double calcNu(double xs, double xe, double fact){//nombre de Nsselt pour un tube
        //xs est le titre de sortie
        //xe est le titre d'entre
        
        double P_calc=te.tHx.P_fl;//P_fl tient compte des pertes de charge singulire et rgulires 
        if(P_calc==0.)P_calc=te.amont.P;
        double T=te.corps.lecorps.getSatTemperature(P_calc, 0)+0.1;
        te.corps.getSubstProperties();
	    te.corps.lecorps.CalcPropCorps(T+0.1,P_calc,0);
 	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
        double ro_v=1/v;
        f=(Double)vProp.elementAt(5);
        double hv=f.doubleValue();
        te.initLambdaMu(T,P_calc, 1);
        double mu_v=te.mu;
        double Re_v=te.getRe();
        T=te.corps.lecorps.getSatTemperature(P_calc, 0)-0.1;
 	    te.corps.lecorps.CalcPropCorps(T-0.1,P_calc,0);
	    vProp=te.corps.lecorps.getSubstProperties();
        f=(Double)vProp.elementAt(3);
        v=f.doubleValue();
        double ro_l=1/v;
        te.corps.getSubstProperties();
        f=(Double)vProp.elementAt(5);
        double hl=f.doubleValue();
 	    te.corps.lecorps.CalcPropCorps(T,P_calc,0);
	    vProp=te.corps.lecorps.getSubstProperties();
	    f=(Double)vProp.elementAt(5);
	    double Cpl=(f.doubleValue()-hl)*10;
            
        double Lv=(hv-hl)*1000.;//Latent heat in J/kg
        
        double Bo;//nombre d'bullition
        if(te.tHx.firstIteration)//On utilise cette formule simplifie avant tout calcul
        Bo=Util.lit_d(te.Dh_value.getText())/4./Util.lit_d(te.L_value.getText());
        else Bo=te.tHx.qlv/te.getFlow()*Util.lit_d(te.Ac_value.getText())/Lv;

	    te.initLambdaMu(T,P_calc, 0);
        double mu_l=te.mu;
        
	    if(false){//si prise en compte laminaire
            double Nu=0;
	        double Nut=C1*Math.pow(turbulentLimit,a_Re)*Math.pow(te.getPr(),b_Pr);
	        double Nul=getNuLamin();
	        double Re=te.getRe();
	        if(Re<=laminarLimit)Nu=Nul;
	        else if(Re>=turbulentLimit)Nu=C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
	        else{
	            double alpha=(Re-laminarLimit)/(turbulentLimit-laminarLimit);
	            Nu=Nul+(Nut-Nul)*alpha;
	        }
	        
            return 0;//Nu*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
        }
        else {
	        double Fact=0;//(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
	 //       System.out.println("Fact "+Fact);
	        //attention : on multiplie Re par (1-x) car dans la corrlation de Gungor et Winterton 
	        //le calcul de Nuliq doit tre fait avec le dbit de la phase liquide seule 
	        if(te.corps.lecorps.isMixture) {
        		te.amont.X=te.amont.corps.X;
	        }
	        double Nut_lo=C1*Math.pow(te.getRe()*(1.-te.amont.X),a_Re)*Math.pow(te.getPr(),b_Pr);
	        
	        double G=te.getFlow()/Util.lit_d(te.Ac_value.getText());
	        double q_wall=Bo*G*Lv;
	        double h_pb=0.625*(Math.pow(P_calc*1e5,0.14)+8.95e-14*P_calc*1e5*P_calc*1e5)
	        		*Math.pow(q_wall,0.7);
			
			System.out.println("\tq_wall\t"+q_wall+"\tG\t"+G);
//			System.out.println("q_wall\t"+q_wall+"\th_lo\t"+h_lo+"\th_pb\t"+h_pb+"\tL\t"+Lv);
			System.out.println("Bo\t"+Bo+"\tro_l\t"+ro_l+"\tro_v\t"+ro_v+"\th_pb\t"+h_pb+"\tPr\t"+te.getPr());
			double NUT_FG=0;
			
			double Nu_db=C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
			
			for(int i=1;i<100;i++){
				double x=i/100.;			
		    //    Nut_lo=(1.-x)*Nu_db;
		        Nut_lo=C1*Math.pow(te.getRe()*(1.-x),a_Re)*Math.pow(te.getPr(),b_Pr);
				
		        double h_lo=Nut_lo/Util.lit_d(te.Dh_value.getText())*te.lambda;

		        //Corrlation Forster-Geist TA
		        double h_FG=1000/2.16*Math.pow(q_wall/1000, 0.65)*Math.pow(P_calc,0.23);
		        //Ghione
//		        h_FG=Math.pow(10, 1.4)/4.57*Math.pow(q_wall, 0.65)*Math.pow(P_calc,0.23);
		        //Reijo Pegonen
//		        h_FG=Math.pow(10, 1.4)/4.44*Math.pow(q_wall, 0.615)*Math.pow(P_calc,0.23);

		        //Calcul du taux de vide
		        double S_gl=Math.pow(ro_l/ro_v,1./3.);//Glissement, selon Moody ou Zivi
		        double voidFract=x/(x+(1-x)*ro_v/ro_l*S_gl);//taux de vide
		        double criticalVoidFract=0.98;
		        double Y=(voidFract-criticalVoidFract)/(1-criticalVoidFract);
		        double B=(voidFract-0.15)/0.35;
		        if(B<0)B=0;
		        if(B>1)B=1;
		        double h_col=0.023*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),1./3.);
		        double h_4=B*h_FG+(1-B)*Nu_db/Util.lit_d(te.Dh_value.getText())*te.lambda;
		        double h_3=Y*h_col+(1-Y)*h_4;
		        double h_par=0;
		        if(voidFract<0.98)h_par=h_FG;
		        else h_par=h_3;
		        
		        NUT_FG=NUT_FG+h_par*Util.lit_d(te.Dh_value.getText())/te.lambda/99.;		
			}
			
		//	NUT_FG=NUT_FG/(1+NUT_FG*Util.lit_d(te.tHx.eLambda_value.getText()));
	        
			System.out.println("Forster Geist NUT\t"+NUT_FG);
			return NUT_FG;
	        
        }
    }

	public double calcDP(){
	    return calcDPdiff();
	}
	public double getFrictionFactor(double Re){
	    if(Re>5000){
	    	return 0.314*Math.pow(Re,-0.25);
	    }
	    else if((Re<5000)&&(Re>3000)){
	    	return 64/5000*(5000-Re)/2000+0.314/Math.pow(5000,0.25)*(Re-3000)/2000;
	    }
	    else{
	        return 64/Re;
	    }
    }
	

	public double getPressFactor(){
	    return Util.lit_d(te.display_value.getText());
    }

	public void setPressFactor(double fact){
	    te.display_value.setText(Util.aff_d(fact));
    }

	
	/**
	 * reads specific technoDesign parameters
	 */
	public void readCaract(String ligne_data){
	    super.readCaract(ligne_data);
        String valeur;
        valeur=Util.extr_value2(ligne_data, "pressure_factor");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.display_value.setText(valeur);
        }
        valeur=Util.extr_value2(ligne_data, "flux density");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.tHx.qlv=value;
            te.tHx.firstIteration=false;
        }
        valeur=Util.extr_value2(ligne_data, "eco flux density");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.tHx.ql=value;
        }
     //   te.tHx.init();
	}

	/**
	 * saves specific technoDesign parameters
	 */
    public String saveCaract(){
	    String h=super.saveCaract();
        h=h+"pressure_factor="+te.display_value.getText()+":"
        		+"flux density="+Util.aff_d(te.tHx.qlv)+":"
		+"eco flux density="+Util.aff_d(te.tHx.ql);
        ;
        return h;
    }
	


	

}