/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.corps.Corps;


public class FinnedAirCoilConfigKJ extends FlowConfig 
{
	double ksi=0;
   	double Fp=1.5e-3;//fin spacing
	double Dc= 7e-3;//outer diameter of a tube collar or outside tube diameter if no collar
	double N= 3;//number of tube rows
	double Pt=21e-3;//center to center tube spacing transverse to air flow direction
	double Pl=12.5e-3;//center to center tube spacing in air flow direction
	double delta_f=7.6e-5;//fin thickness

	public FinnedAirCoilConfigKJ (){
     }

    public String getCode(){
        return "airCoil_KJ";
    }
	public String getClassDescription(){
	    return "Kim & Jacobi correlation for fin air coil flow outside tubes";
	}
	
  
    public FinnedAirCoilConfigKJ (TechnoExch te){
        super(te);
        NuCorrel="Finned air coil 3";
        diph=false;
    }


    public double calcNuTube(){//

        te.corps.lecorps.CalcPropCorps(te.amont.T,te.amont.P,1.);
        te.corps.getSubstProperties();
        double ro=1./te.corps.V;	
        te.initLambdaMu(te.amont.T,te.amont.P,1.);
        double mu=te.mu;
        double lambda=te.lambda;
        double G=te.getFlow()/Util.lit_d(te.Ac_value.getText());
        double v=G/ro;
   //     te.sf.init();
    	
       /**/ 
        te.sf.JLabel5.setText("Fin spacing Fp");//C1_value
        te.sf.JLabel4.setText("Transverse pitch Pt");//Re_value
        te.sf.JLabel6.setText("Parallel pitch Pl");//Pr_value
        te.sf.JLabel8.setText("Row number N");//Viscosity_value
       	Fp=Util.lit_d(te.sf.C1_value.getText());
       	Pt=Util.lit_d(te.sf.Re_value.getText());
       	Pl=Util.lit_d(te.sf.Pr_value.getText());
       	N=Util.lit_d(te.sf.Viscosity_value.getText());
       	Dc=Util.lit_d(te.Dh_value.getText());
        System.out.println("Finned air coil Fp\t"+Fp+"\tPt\t"+Pt+"\tPl\t"+Pl
        		+"\tN\t"+N+"\tDc\t"+Dc);
     	
	    double dh=Util.lit_d(te.Dh_value.getText());

 	
        double Re_dc=G*dh/mu;
        
        double J=0.4313*Math.pow(Re_dc, -0.209)*Math.pow(Fp/Dc, 1.001)*Math.pow(Pl*N/Dc, -0.4967);
 		
        
        double alpha=0.2, delta=0.03,gamma=0.08;
        double Jmb=0.6522*Math.pow(Re_dc, -0.5403)*Math.pow(alpha, -0.1541)*
        		Math.pow(delta, 0.1499)*Math.pow(gamma, -0.0678);
        Jmb=Jmb*Math.pow((1+5.269e-5*Math.pow(Re_dc, 1.34)*Math.pow(alpha, 0.504)*
        		Math.pow(delta, 0.456)*Math.pow(gamma, -1.055)),0.1);
 		
 //       double Nu=Jmb*Re_dc*Math.pow(te.getPr(),1./3.);
        double Pr=te.getPr();
        
        System.out.println("Finned air coil Pr\t"+Pr+"\tRe_dc\t"+Re_dc+"\tG\t"+G
        		+"\tJmb\t"+Jmb+"\tJ\t"+J);
        double Nu_jmb=Jmb*Re_dc*Math.pow(Pr,1./3.);
        double Nu=J*Re_dc*Math.pow(Pr,1./3.);
        double Nu1=0.187*Math.pow(Re_dc,0.6479);
        double Nu2=0.3522*Math.pow(Re_dc,0.5991);
      //  Nu3=Fp*Math.pow(Re_dc,Pt)*Math.pow(Pr,Pl);

        double Nu3=C1*Math.pow(Re_dc,a_Re)*Math.pow(Pr,b_Pr);
 

        System.out.println("Finned tubes"+"\tNu_jmb\t"+Nu_jmb+"\tNu\t"+Nu
        		+"\tNu1\t"+Nu1+"\tNu2\t"+Nu2+"\tNu3\t"+Nu3);
 		
        return Nu;
//	        		C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);//*Math.pow(viscCorr,c_Visc);
    }
    	   
	public double calcDP(){
	    return calcDP(te.amont.V);
	}
	
	public double calcDP(double vl){
	    double dP;
	       te.corps.lecorps.CalcPropCorps(te.amont.T,te.amont.P,1.);
	        te.corps.getSubstProperties();
	        double ro=1./te.corps.V;	
	        te.initLambdaMu(te.amont.T,te.amont.P,1.);
	        double mu=te.mu;
	        double lambda=te.lambda;
	        double G=te.getFlow()/Util.lit_d(te.Ac_value.getText());
	        double v=G/ro;
		
	        /* */te.sf.JLabel5.setText("Fin spacing Fp");//C1_value
	        te.sf.JLabel4.setText("Transverse pitch Pt");//Re_value
	        te.sf.JLabel6.setText("Parallel pitch Pl");//Pr_value
	        te.sf.JLabel8.setText("Row number N");//Viscosity_value
	       	Fp=Util.lit_d(te.sf.C1_value.getText());
	       	Pt=Util.lit_d(te.sf.Re_value.getText());
	       	Pl=Util.lit_d(te.sf.Pr_value.getText());
	       	N=Util.lit_d(te.sf.Viscosity_value.getText());
	       	Dc=Util.lit_d(te.Dh_value.getText());	    	

	        
		    double flow=te.getFlow();
		    double Ac=Util.lit_d(te.Ac_value.getText());
		    double dh=Util.lit_d(te.Dh_value.getText());
		    double L=Util.lit_d(te.L_value.getText());
		    double C=flow*vl/Ac;
	        double Re_dc=G*dh/mu;

	        
	        double f=3.826*Math.pow(Re_dc, -0.5959)*Math.pow(Fp/Dc, -0.2392)*Math.pow(Pl*N/Dc, 0.04879);
	        double Pr=te.getPr();
	        
/*	        //Nu3=Fp*Math.pow(Re_dc,Pt)*Math.pow(Pr,Pl);
	        double Nu3=C1*Math.pow(Re_dc,a_Re)*Math.pow(Pr,b_Pr);
	        
	   //     ksi=2*Nu3*Nu3*Nu3/Pr*32.97/Re_dc/Re_dc/Util.lit_d(te.sf.Viscosity_value.getText());
	  //      System.out.println("Finned air coil dP\t"+"\tksi\t"+ksi+"\tf\t"+f);
	        ksi=30.331*Nu3*Nu3*Nu3/Pr/Re_dc/Re_dc/c_Visc;
	
	        
	        f=ksi/4;*/
	        te.frictionFactor_value.setText(Util.aff_d(f,6));
		    dP=f*vl/2*flow*flow/Ac/Ac*L/dh/100000;//Perte rgulire en bar
	        System.out.println("Finned air coil dP\t"+"\tksi\t"+ksi+"\tf\t"+f);
	 			        
			
	    return dP;
    }

    
	

	

}