/*
Copyright Renaud GICQUEL 2009  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;

/**
 * Classe de dimensionnement technologique d'une turbine avec cartographie
 * Technological design class for mapped turbines
 */

public class MultiStageMappedTurbine extends TechnoTurb
{
	double alphaA, alphaB, alphaC, alphaD;	
	double betaA, betaB, betaC, betaD;	
	double gammaA, gammaB, gammaC, gammaD;	
	double alphaK1, alphaK2, alphaK3, alphaR1, alphaR2;	
	double betaK1, betaK2, betaK3, betaR1, betaR2;	
	double gammaK1, gammaK2, gammaK3, gammaR1, gammaR2;	
	
	double a,b,c,d,K1,K2,K3,R1,R2,xSurge,ySurge,xLim,yLim,Nmin,Nmax,Nref;
	double mRef=1,RdMax=1,etaRef=1,racT0,T0,P0,N0;
	double mDesign=1,RpDesign=1,etaDesign=1;
	
	
	TurbineMapDataFrame tcf;

	public MultiStageMappedTurbine(){
	}

	public MultiStageMappedTurbine(Projet proj, String turbineName, PointThopt amont, PointThopt aval){
		super(proj, turbineName, amont, aval);
	    this.turbineName=componentName;
	    tcf=new TurbineMapDataFrame(this);
//	    tcf.show();
	    tcf.loadSettings();
	    setupPanel();
	}
	public MultiStageMappedTurbine(Projet proj, String turbineName){
		super(proj, turbineName);
	    this.turbineName=componentName;
	    setupPanel();
	}
    void setupPanel(){
        super.setupPanel();
		JLabeImg.setText("Turbine maps");
		JPanel1.add(JLabeImg);
		JLabeImg.setBounds(3,50,228,36);
		JLabeImg.setBounds(372,87,250,300);
		JLabel1.setText("Turbine data");
		JLabel1.setBounds(3,80,228,36);
		JLabel1.setBounds(550,0,228,36);
        
        JPanel1.add(JLabel12);
		JLabel5.setText("eta design");
		//etaMax_value.setText("0.85");
		JLabel6.setText("Rp design");
		//etaLim_value.setText("-10");
		JLabel4.setText("m design");
		//outletArea_value.setText("0.3");
		JLabel7.setText("relative rot. speed");
		JLabel7.setBounds(new Rectangle(4, 177, 108, 24));
		Kh_value.setBounds(148,177,120,24);
		Kh_value.setEditable(false);
		Kh_value.setText("1");
		JLabel14.setText("relative isentr. eff.");
		JLabel14.setBounds(4,207,144,24);
		risentr_value.setBounds(148,207,120,24);
		JLabel15.setText("relative pressure ratio");
		JLabel15.setBounds(4,267,144,24);
		m_value.setBounds(new Rectangle(148, 237, 120, 24));
		JLabel12.setText("relative flow rate");
		JLabel12.setBounds(new Rectangle(4, 237, 132, 24));
		display_value.setBounds(new Rectangle(148, 267, 120, 24));
		SymMouse aSymMouse = new SymMouse();
		JLabeImg.addMouseListener(aSymMouse);
		JLabel1.addMouseListener(aSymMouse);
		display_value.setEditable(false);
		m_value.setEditable(false);
		risentr_value.setEditable(false);
		
		JLabel8.setBounds(new Rectangle(1, 320, 144, 24));
		alphaBaumann_value.setBounds(new Rectangle(145, 320, 120, 24));
		JPanel1.remove(N_value);
		JLabel2.setText("outlet area (m2)");
		JLabel2.setBounds(new Rectangle(1, 384, 144, 24));
		JPanel1.remove(displayLabel);
		
		JLabel18.setBounds(new Rectangle(1, 290, 144, 24));
		stageNumber_value.setBounds(new Rectangle(145, 290, 120, 24));
		
		
        N=1;
	}

    public String getType(){
        return "MultiStageMappedTurbine";
    }
	
    public String getClassName(){
        return "MultiStageMappedTurbine";
    }
    public String getClassCode(){
        return "Expansion";
    }

	//{{DECLARE_CONTROLS
	//}}


	/*
	A faire :
	- vrifier l'homognit du calcul de N rduit
	*/

public void initSettings(){
	alphaA=Util.lit_d(tcf.alphaA_value.getText());
	alphaB=Util.lit_d(tcf.alphaB_value.getText());
	alphaC=Util.lit_d(tcf.alphaC_value.getText());
	alphaD=Util.lit_d(tcf.alphaD_value.getText());

	betaA=Util.lit_d(tcf.betaA_value.getText());
	betaB=Util.lit_d(tcf.betaB_value.getText());
	betaC=Util.lit_d(tcf.betaC_value.getText());
	betaD=Util.lit_d(tcf.betaD_value.getText());
	
	gammaA=Util.lit_d(tcf.gammaA_value.getText());
	gammaB=Util.lit_d(tcf.gammaB_value.getText());
	gammaC=Util.lit_d(tcf.gammaC_value.getText());
	gammaD=Util.lit_d(tcf.gammaD_value.getText());
	
	alphaK1=Util.lit_d(tcf.alphaK1_value.getText());
	alphaK2=Util.lit_d(tcf.alphaK2_value.getText());
	alphaK3=Util.lit_d(tcf.alphaK3_value.getText());
	alphaR1=Util.lit_d(tcf.alphaR1_value.getText());
	alphaR2=Util.lit_d(tcf.alphaR2_value.getText());

	betaK1=Util.lit_d(tcf.betaK1_value.getText());
	betaK2=Util.lit_d(tcf.betaK2_value.getText());
	betaK3=Util.lit_d(tcf.betaK3_value.getText());
	betaR1=Util.lit_d(tcf.betaR1_value.getText());
	betaR2=Util.lit_d(tcf.betaR2_value.getText());

	gammaK1=Util.lit_d(tcf.gammaK1_value.getText());
	gammaK2=Util.lit_d(tcf.gammaK2_value.getText());
	gammaK3=Util.lit_d(tcf.gammaK3_value.getText());
	gammaR1=Util.lit_d(tcf.gammaR1_value.getText());
	gammaR2=Util.lit_d(tcf.gammaR2_value.getText());

	//conditions de rfrence
	mRef=Util.lit_d(tcf.mRef_value.getText());
	RdMax=Util.lit_d(tcf.RdMax_value.getText());
	etaRef=Util.lit_d(tcf.etaRef_value.getText());
	T0=Util.lit_d(tcf.T0_value.getText());
	P0=Util.lit_d(tcf.P0_value.getText());
	Nmin=Util.lit_d(tcf.Nmin_value.getText());
	Nmax=Util.lit_d(tcf.Nmax_value.getText());
	Nref=Util.lit_d(tcf.Nref_value.getText());
	racT0=Math.pow(T0,0.5);//racine de T0 pour correction vitesse et dbit corrigs
	
}

    public void setNparameters(){
        a=getA(N);
        b=getB(N);
        c=getC(N);
        d=getD(N);
        K1=getK1(N);
        K2=getK2(N);
        K3=getK3(N);
        R1=getR1(N);
        R2=getR2(N);
    }
    public double getA(double N){
        return alphaA+betaA*N+gammaA*N*N;
    }
    public double getB(double N){
        return alphaB+betaB*N+gammaB*N*N;
    }
    public double getC(double N){
        return alphaC+betaC*N+gammaC*N*N;
    }
    public double getD(double N){
        return alphaD+betaD*N+gammaD*N*N;
    }
    public double getK1(double N){
        return alphaK1+betaK1*N+gammaK1*N*N;
    }
    public double getK2(double N){
        return alphaK2+betaK2*N+gammaK2*N*N;
    }
    public double getK3(double N){
        return alphaK3+betaK3*N+gammaK3*N*N;
    }
    public double getR1(double N){
        return alphaR1+betaR1*N+gammaR1*N*N;
    }
    public double getR2(double N){
        return alphaR2+betaR2*N+gammaR2*N*N;
    }
    
	public void setDesignValues(){
	    RpDesign=Util.lit_d(tauMax_value.getText());
	    mDesign=Util.lit_d(etaLim_value.getText());
	    etaDesign=Util.lit_d(etaMax_value.getText());
	}
	public void setN(double N){
	    N0=N;
	    updateN();
	}
	public void updateN(){
	    double racT=Math.pow(amont.T,0.5);//racine de T pour correction vitesse corrige
	    N=N0*racT0/racT;
	    Kh_value.setText(Util.aff_d(N,5));
	}
	/**
	 * gets the reduced speed corresponding to Rp and massFlow
	 */
	double getNfromRpAndFlow(double Rd, double massFlow){
	  //  double N=0;
        double rd=Math.pow(Rd,1./stageNumber);
        if(rd>RdMax)rd=RdMax;
        double A=gammaA+gammaB/rd+gammaC/rd/rd+gammaD/rd/rd/rd;
        double B=betaA+betaB/rd+betaC/rd/rd+betaD/rd/rd/rd;
        double C=alphaA+alphaB/rd+alphaC/rd/rd+alphaD/rd/rd/rd;
        N=0.6;
        double x=A*N*N+B*N+C;
        N=1.2;
        double x2=A*N*N+B*N+C;
        
        // marche, mais seulement si le dbit et le rapport de dtente rd sont dans des intervalles acceptables
        C=C-massFlow/mDesign*mRef;
        double delta=B*B-4.*A*C;
        N=(-B-Math.pow(delta,0.5))/2./A;        
	    if(N<=0){
 	        String message="Watch out! The N value is not within the interval limits\nThe turbocompressor map may be invalid"; 
	        JOptionPane.showMessageDialog(new JFrame(),message);
	    }
	    return N;
	}
	
	/**
	 * gets the number of stages corresponding to the reduced speed and massFlow
	 */
	int getStageNumber(double N, double massFlow){
	    double Rd=amont.P/aval.P;
	    double[] res=new double[100];
	    for(int k=1;k<100;k++){
            double rd=Math.pow(Rd,1./k);
            if(rd>RdMax)rd=RdMax;
            double A=gammaA+gammaB/rd+gammaC/rd/rd+gammaD/rd/rd/rd;
            double B=betaA+betaB/rd+betaC/rd/rd+betaD/rd/rd/rd;
            double C=alphaA+alphaB/rd+alphaC/rd/rd+alphaD/rd/rd/rd;
            double x=A*N*N+B*N+C;
            res[k]=(x-massFlow/mDesign*mRef)*(x-massFlow/mDesign*mRef);
        }
        double min=res[1];
        int j=1;
	    for(int k=2;k<100;k++){
            if(res[k]<min){
                min=res[k];
                j=k;
            }
        }
	    return j;
	}
	
	

    public double getMassFlowRate(double Rd){
        double rd=Math.pow(Rd,1./stageNumber);
        if(rd>RdMax)rd=RdMax;
        double z=(a+b/rd+c/rd/rd+d/rd/rd/rd);
	    double racT=Math.pow(amont.T,0.5);//racine de T pour correction dbit corrig
        double reducedFlow=z*racT0/racT/P0*amont.P;
        z=reducedFlow*mDesign/mRef;
	    m_value.setText(Util.aff_d(z/mDesign,5));
	    display_value.setText(Util.aff_d(Rd/RpDesign,4));
        return z;
    }
    
	public double getMassFlow(){
	    return getMassFlowRate(amont.P/aval.P);
	}
	
	public double getRisentr(){
	    return getRisentr(amont.P/aval.P);
	}
	
	double getRisentr(double Rd){
        double rd=Math.pow(Rd,1./stageNumber);
        if(rd>RdMax)rd=RdMax;
		double eta=(K1+K2*(rd-R1)*(rd-R1)+K3/(rd-R2))/etaRef*etaDesign;
		
	    double k=getPolytropicCoefficient();
	    double beta_k=(k-1.)/k;
	    double beta=beta_k/eta;
	    if(!tcf.modeEta.equals("polytropic")){//cas isentropique
	        double eta_polytr=Math.log(1+eta*(Math.pow(rd,-beta_k)-1.))/beta_k/Math.log(1/rd);
	        beta=beta_k/eta_polytr;
	    }
	    eta=(Math.pow(Rd,-beta_k)-1.)/(Math.pow(Rd,-beta)-1.);
		
	    if(eta<0.25)eta=0.25;
	    risentr_value.setText(Util.aff_d(eta/etaDesign,4));
	    return eta;
	}
	
	double getRelativeFlow(double massFlowRate){//deprecated
	    double racT=Math.pow(amont.T,0.5);//racine de T pour correction dbit corrig
        double reducedFlow=massFlowRate/mDesign*racT/racT0*P0/amont.P;
	    m_value.setText(Util.aff_d(reducedFlow,4));
	    return reducedFlow;
    }
    
	double getDesignRisentr(){//rendement isentropique initial de la transfo compression
        String[] args=new String[2];
        args[0]="process";
        args[1]=componentName;
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(11);
        return f.doubleValue();
	}

	public void makeDesign(){//cale le point nominal de la cartographie sur les conditions de la compression
	    //dans un deuxime temps, on pourra en dduire les dimensions
	    
	    initSettings();//relit les paramtres des cartographies
	    setNparameters();//calcule les paramtres qui dpendent de N
	    updateN();
        setStageNumber();
	    RpDesign=amont.P/aval.P;
	    etaDesign=getDesignRisentr();
	    mDesign=getFlow();
//	    outletArea_value.setText(Util.aff_d(mDesign,5));
	    tauMax_value.setText(Util.aff_d(RpDesign,5));
	    etaLim_value.setText(Util.aff_d(mDesign,5));
	    etaMax_value.setText(Util.aff_d(etaDesign,5));
	    
	    //conditions de rfrence
	    racT0=Math.pow(amont.T,0.5);//racine de T0 pour correction vitesse et dbit corrigs
	    P0=amont.P;
	}
	
		/**
	 * cheks if the compressor reduced speed is within the map limits
	 */
	void checkMapValidity(){
        if(N<Nmin){
	        String message="The compressor reduced speed is lower than the minimum  \nThe turbine map may be invalid";  
	        JOptionPane.showMessageDialog(new JFrame(),message);
        }
        if(N>Nmax){
	        String message="The compressor reduced speed is greater than the maximum  \nThe turbine map may be invalid";  
	        JOptionPane.showMessageDialog(new JFrame(),message);
        }
    }

    public void setImageFile(String fileName){
        if(map==null)map=new MapImage("Turbine maps",this, im);
    //    map.show();
        map.setImageFile(fileName);
    }
    public String getMapImage(){
        if(map==null)return "";
        else return map.imageFile;
    }
    
    public void setDataFile(String fileName){
        tcf.setDataFile(fileName);
    }
    public String getDataFile(){
        return tcf.dataFileName;
    }
    
	class SymMouse extends java.awt.event.MouseAdapter
	{

		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
				MappedTurbine_mousePressed(event);
		}
	}
    
	
    void MappedTurbine_mousePressed(java.awt.event.MouseEvent event)
    {
		    Object object = event.getSource();
	    int nb_click=event.getClickCount();
	    if(nb_click>=2){
	        if (object == JLabeImg){
	                if(map==null)map=new MapImage("Turbine maps",this, im);
	                map.show();
	        }
	        if (object == JLabel1){
	                if(tcf==null)tcf=new TurbineMapDataFrame();
	                tcf.show();
	        }
        }
    }
    
}
 