/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.*;

import javax.swing.*;

import rg.thopt.*;

public class TechnoHx extends ExtTechnoDesign implements Inversable
{
protected static java.util.ResourceBundle resIntTh_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
	public TechnoExch techc, techf;
    public String config_f,config_c, hXname, hotFluid, coldFluid;
	double Tf,Tc,lambda_f,mu_f,lambda_c,mu_c;
	public double UA;
	double Pr_f,Pr_c,Re_f,Re_c,Nu_f,Nu_c, Gc,Gf,dPc,dPf,hc,hf;
    double Tci,Tfi,mCpc1,mCpc2,epsi1,R1,UA1,NUT1,epsi2,R2,UA2,NUT2,corpscX,corpsfX;
	boolean debug=false,isThreeStep=false, makesDesign=false;
    PointThopt amontHot,amontCold, avalHot, avalCold;
	
    double Tcl,Tcv,Tfl,Tfv,Pce,Pfe,Xce,Xcs,Xfe,Xfs,Lc,Lf,DTmin,U,A,
    mCpfl,mCpcl,epsil,Rl,UAl,NUTl,Ul,Al,DTMLl,DTMLlv,DTMLv,
    mCpfv,mCpcv,epsiv,Rv,UAv,NUTv,Uv,Av,
    mCpflv,mCpclv,epsilv,Rlv,UAlv,NUTlv,Ulv,Alv;
    double mCpc,mCpf,$test,Sigma_code,Tce,Tcs,Tfe,Tfs,mc,mf;
    double Cpc,Cpf,$Tce,$Tcs,$Tfe,$Tfs,epsilon,DHc,DHf;
    double ql,qlv,qv;
    boolean firstIteration=true;//sert  initialiser le nombre d'bullition et q_wall
    
    protected int z_pinct,z_libre,z_effic,$Icas,$sigma;
    protected double code_Tce,code_Tcs,code_Tfe,code_Tfs,code_mc,code_mf;
	String hvc="", hlvc="", hlc="", hvf="", hlvf="", hlf="", nutCorrelationName=""
			, pdcCorrelationName="";

	double P_cv, P_cl, P_cs, P_fs, P_fv, P_fl, P_fe, Psat, Tsat, Pf_inlet, Pc_inlet, Tf_inlet, Tc_inlet;
	double dPSing, dPf_l, dPf_lv, dPf_v, dPc_l, dPc_lv, dPc_v;
  
//    CorpsThopt corps;
	
	
	JPanel techPanc,techPanf;
	Projet proj;
	
	public TechnoHx(){
	}
	

	public TechnoHx(Projet proj, String hXname, PointThopt amontHot, PointThopt avalHot, PointThopt amontCold, PointThopt avalCold)
	{
		this();
		this.proj=proj;
		this.hXname=hXname;
		componentName=hXname;
        String[] args=new String[2];
        args[0]="heatEx";
        args[1]=hXname;
        Vector vProp=proj.getProperties(args);
        if(vProp.size()==0){
	        String msg = "Watch out!: heat exchanger "+hXname+" does not exist in the project";
//modRG        JOptionPane.showMessageDialog(tde, msg);  
        }else{
            hotFluid=(String)vProp.elementAt(0);  
            coldFluid=(String)vProp.elementAt(1);
            
            this.amontHot=amontHot;
            this.amontCold=amontCold; 
            this.avalHot=avalHot; 
            this.avalCold=avalCold;
            
            techc=new TechnoExch(proj, this, hotFluid, amontHot, avalHot);
            techf=new TechnoExch(proj, this, coldFluid, amontCold, avalCold);
            
            techc.setOtherTechnoExch();
            techf.setOtherTechnoExch();
    		
		    JLabCompName.setText(hXname);
	        hotName.setText(hotFluid);
	        coldName.setText(coldFluid);
	        setupPanel();
            setupTechHx();
        }
	}
		public TechnoHx(Projet proj, String hXname)
	{
		this();
		this.proj=proj;
		this.hXname=hXname;
		componentName=hXname;
        String[] args=new String[2];
        args[0]="heatEx";
        args[1]=hXname;
        Vector vProp=proj.getProperties(args);
        hotFluid=(String)vProp.elementAt(0);  
        coldFluid=(String)vProp.elementAt(1);

        techc=new TechnoExch(proj, this, hotFluid);
        techf=new TechnoExch(proj, this, coldFluid);
        
        this.amontHot=techc.amont;
        this.amontCold=techf.amont; 
        this.avalHot=techc.aval; 
        this.avalCold=techf.aval;
        
        
        techc.setOtherTechnoExch();
        techf.setOtherTechnoExch();
		
		JLabCompName.setText(hXname);
	    hotName.setText(hotFluid);
	    coldName.setText(coldFluid);
	    setupPanel();
        setupTechHx();
	}

	
	void setupPanel(){
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,800,500);
		JLabhlc.setText(resIntTh_fr.getString("hlc"));
		JPanel1.add(JLabhlc);
		JLabhlc.setForeground(java.awt.Color.red);
		JLabhlc.setBounds(10,50,280,24);
		JLabhlf.setText("hlf");
		JPanel1.add(JLabhlf);
		JLabhlf.setForeground(java.awt.Color.blue);
		JLabhlf.setBounds(10,132,280,24);
		JLabhlvc.setText("hlvc");
		JPanel1.add(JLabhlvc);
		JLabhlvc.setForeground(java.awt.Color.red);
		JLabhlvc.setBounds(10,74,280,24);
		JLabhlvf.setText("hlvf");
		JPanel1.add(JLabhlvf);
		JLabhlvf.setForeground(java.awt.Color.blue);
		JLabhlvf.setBounds(10,156,280,24);
		JLabhvf.setText("hvf");
		JPanel1.add(JLabhvf);
		JLabhvf.setForeground(java.awt.Color.blue);
		JLabhvf.setBounds(10,180,280,24);
		JLabhvc.setText("hvc");
		JPanel1.add(JLabhvc);
		JLabhvc.setForeground(java.awt.Color.red);
		JLabhvc.setBounds(10,98,280,24);
	/*	JPanel2.setLayout(null);
		JPanel1.add(JPanel2);
		JPanel2.setBounds(12,320,708,196);
		JLabel6.setText("Hx area");
		JPanel2.add(JLabel6);
		JLabel6.setForeground(new java.awt.Color(102,102,153));
		JLabel6.setBounds(444,108,96,24);
		JPanel2.add(A_value);
		A_value.setBounds(588,108,104,24);
		JLabel11.setText("UA1");
		JPanel2.add(JLabel11);
		JLabel11.setBounds(12,84,96,24);
		JPanel2.add(UA1_value);
		UA1_value.setBounds(144,84,104,24);
		JLabel12.setText("UA2");
		JPanel2.add(JLabel12);
		JLabel12.setBounds(12,108,96,24);
		JPanel2.add(UA2_value);
		UA2_value.setBounds(144,108,104,24);
		JLabUl.setText("Ul");
		JPanel2.add(JLabUl);
		JLabUl.setForeground(new java.awt.Color(102,102,153));
		JLabUl.setBounds(300,0,96,24);
		JLabUlv.setText("Ulv");
		JPanel2.add(JLabUlv);
		JLabUlv.setForeground(new java.awt.Color(102,102,153));
		JLabUlv.setBounds(300,24,96,24);
		JLabUv.setText("Uv");
		JPanel2.add(JLabUv);
		JLabUv.setForeground(new java.awt.Color(102,102,153));
		JLabUv.setBounds(300,48,96,24);
		JLabAv.setText("Av");
		JPanel2.add(JLabAv);
		JLabAv.setForeground(new java.awt.Color(102,102,153));
		JLabAv.setBounds(432,48,96,24);
		JLabAl.setText("Al");
		JPanel2.add(JLabAl);
		JLabAl.setForeground(new java.awt.Color(102,102,153));
		JLabAl.setBounds(432,0,96,24);
		JLabAlv.setText("Alv");
		JPanel2.add(JLabAlv);
		JLabAlv.setForeground(new java.awt.Color(102,102,153));
		JLabAlv.setBounds(432,24,96,24);
		JLabel15.setText("DT step");
		JPanel2.add(JLabel15);
		JLabel15.setBounds(12,36,96,24);
		DTstep_value.setText("2.5");
		JPanel2.add(DTstep_value);
		DTstep_value.setBounds(144,36,104,24);*/
		JLabel3.setText("e/\u03BB");//e/lambda
		JPanel1.add(JLabel3);
		JLabel3.setBounds(450,96,96,24);
		JPanel1.add(eLambda_value);
		eLambda_value.setText("0");
		eLambda_value.setBounds(550,96,104,24);
		JLabel4.setText("Hx design area");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(450,130,96,24);
		JPanel1.add(ADesign_value);
		ADesign_value.setBounds(550,130,104,24);
		JLabel5.setText("average U");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(450,164,96,24);
		JPanel1.add(U_value);
		U_value.setBounds(550,164,104,24);
	//	JPanel3.setLayout(null);
	//	JPanel1.add(JPanel3);
	//	JPanel3.setBounds(0,0,516,330);
		JPanel1.add(hotName);
		hotName.setForeground(java.awt.Color.red);
		hotName.setBounds(60,250,215,17);
		JPanel1.add(coldName);
		coldName.setBounds(60,406,215,17);
		
		JLabhlc.setText(resIntTh_fr.getString("hlc"));
		JLabhlf.setText(resIntTh_fr.getString("hlf"));
		JLabhlvc.setText(resIntTh_fr.getString("hlvc"));
		JLabhlvf.setText(resIntTh_fr.getString("hlvf"));
		JLabhvf.setText(resIntTh_fr.getString("hvf"));
		JLabhvc.setText(resIntTh_fr.getString("hvc"));
		
	}
	
	public void setupTechHx(){
	    techPanc=techc.JPanel1;
	    JPanel1.add(techPanc);
	    techPanc.setBounds(0, 172, 804,245);
	    techPanf=techf.JPanel1;
	    JPanel1.add(techPanf);
	    techPanf.setBounds(0, 325, 804,245);
		JLabel5.setText("");
		U_value.setVisible(false);
	    
	}
	
	public String getNom(){
	    return "TechnoHx";
	}
	public String getClassType(){
	    return "TechnoHx";
	}

    public String getClassCode(){
        return "HeatEx";
    }
    
    public String getClassName(){
        return "TechnoHx";
    }


    public String getType(){
        return "basic heat exchanger";
    }
    
  	public String getClassDescription(){
	    return "TechnoHx\n\nauthor : R. Gicquel  march 2008\n\nRef : archive ";
	}


	//{{DECLARE_CONTROLS
	javax.swing.JLabel JLabhlc = new javax.swing.JLabel();
	javax.swing.JLabel JLabhlf = new javax.swing.JLabel();
	javax.swing.JLabel JLabhlvc = new javax.swing.JLabel();
	javax.swing.JLabel JLabhlvf = new javax.swing.JLabel();
	javax.swing.JLabel JLabhvf = new javax.swing.JLabel();
	javax.swing.JLabel JLabhvc = new javax.swing.JLabel();
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField U_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField A_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JTextField UA1_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JTextField UA2_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabUl = new javax.swing.JLabel();
	javax.swing.JLabel JLabUlv = new javax.swing.JLabel();
	javax.swing.JLabel JLabUv = new javax.swing.JLabel();
	javax.swing.JLabel JLabAv = new javax.swing.JLabel();
	javax.swing.JLabel JLabAl = new javax.swing.JLabel();
	javax.swing.JLabel JLabAlv = new javax.swing.JLabel();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JTextField DTstep_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField eLambda_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	public javax.swing.JTextField ADesign_value = new javax.swing.JTextField();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JLabel hotName = new javax.swing.JLabel();
	javax.swing.JLabel coldName = new javax.swing.JLabel();
	javax.swing.JLabel JLabCompName = new javax.swing.JLabel();
	//}}

	//{{DECLARE_MENUS
	//}}

/**
* updates the heat exchanger Cp, mCp, Te and Ts
*
**/
	public void resetHX(){
		techc.updateDeltaH();
		techf.updateDeltaH();
	    if((techc.DeltaH>=0)||(techf.DeltaH<=0)){//construction absurde
	        String message="heat exchanger ill built "+getName(); 
	      //modRG	        JOptionPane.showMessageDialog(tde,message);
	    }
        if(techc.amont.T!=techc.aval.T){
            Cpc=Math.abs(techc.DeltaH/(techc.amont.T-techc.aval.T));
            Tcs=techc.aval.T;
        }
        else{ //vaporization or condensation
            Cpc=Math.abs(techc.DeltaH/0.1);
            Tcs=techc.aval.T-0.1;
        }
        mc=techc.getFlow();
        mCpc=Cpc*mc;
        Tce=techc.amont.T;
        if(techf.amont.T!=techf.aval.T){
            Cpf=Math.abs(techf.DeltaH/(techf.amont.T-techf.aval.T));
            Tfs=techf.aval.T;
        }
        else{ //vaporization or condensation
            Cpf=Math.abs(techf.DeltaH/0.1);
            Tfs=techf.aval.T+0.1;
        }
        mf=techf.getFlow();
        mCpf=Cpf*mf;
        Tfe=techf.amont.T;
        double TinfF=Tfe;
        double TsupF=Tfs;
        double Tinfcor=Tcs;
        double Tsupcor=Tce;
        double mCpcor=mc*Cpc;
        double mCpF=mf*Cpf;
        double R, NUT;
        if (mCpcor>mCpF){
            epsilon=(TsupF-TinfF)/(Tsupcor-TinfF);
            R=mCpF/mCpcor;
            NUT=NUT_epsi(epsilon,R) ;
            UA=mCpF*NUT;
        }
        else{
            epsilon=(Tsupcor-Tinfcor)/(Tsupcor-TinfF);
            R=mCpcor/mCpF;
            NUT=NUT_epsi(epsilon,R) ;
            UA=mCpcor*NUT;
        }

    }
	double NUT_epsi(double epsilon, double R){

	    //cette m�thode calcule le NUT � partir de epsilon et de R
	  //en fonction du type d'�changeur
	    double X;
        if(R!=1){
            X=(1-epsilon*R)/(1-epsilon);
            return Math.log(X)/(1-R);
        }
        else return epsilon/(1-epsilon);
	}
    
    public double getPinchValue(){
        return DTmin;
    }


    //Calculs des U
    public double getUv(double xc,double xf){
        double u=1;
        if((techc!=null)&&(techf!=null)){
        //    calcNusselt((Tce+Tcv)/2., (Tfs+Tfv)/2., Pce, Pfe, xc, xf, mCpcv/mc, mCpfv/mf, false,false);
            techc.calcNusselt((Tce+Tcv)/2., techc.amont.P, xc, mCpcv/mc, false,false);
            techf.calcNusselt((Tfs+Tfv)/2., techf.amont.P, xf, mCpfv/mf, false,false);
            u=get_U();

	        if(debug)System.out.println("techc.Pr vap "+techc.getPrCpx()+"  Cpx "+techc.Cpx+"  techc.lambda "+techc.lambda+"  techc.mu "+techc.mu);
	        if(debug)System.out.println("techf.Pr vap "+techf.getPrCpx()+"  Cpx "+techf.Cpx+"  techf.lambda "+techf.lambda+"  techf.mu "+techf.mu);
 
	        	hvc=Util.aff_d(hc,getPrecision(hc));
	        	hvf=Util.aff_d(hf,getPrecision(hf));
            JLabhvc.setText(resIntTh_fr.getString("hvc")+" = "+Util.aff_d(hc,getPrecision(hc))+" Re = "+Util.aff_d(techc.Re,getPrecision(techc.Re)));
            JLabhvf.setText(resIntTh_fr.getString("hvf")+" = "+Util.aff_d(hf,getPrecision(hf))+" Re = "+Util.aff_d(techf.Re,getPrecision(techf.Re)));
        }
        return u;
    }

    public double getUl(double xc,double xf){
        double u=1;
        if((techc!=null)&&(techf!=null)){
        //    calcNusselt((Tcl+Tcs)/2., (Tfl+Tfe)/2., Pce,Pfe, xc, xf, mCpcl/mc, mCpfl/mf, false,false);
            techc.calcNusselt((Tcl+Tcs)/2., techc.amont.P, xc, mCpcl/mc, false,false);
            techf.calcNusselt((Tfl+Tfe)/2., techf.amont.P, xf, mCpfl/mf, false,false);
            u=get_U();
  	        if(debug)System.out.println("getUl Tcmoyenne "+(Tcl+Tcs)/2.+"  techc.Re "+techc.Re+"  techc.lambda "+techc.lambda+"  techc.mu "+techc.mu);
  	        if(debug)System.out.println("techc.Pr liq "+techc.getPrCpx()+"  Cpx "+techc.Cpx+"  techc.lambda "+techc.lambda+"  techc.mu "+techc.mu);
            if(debug)System.out.println("techf.Pr liq "+techf.getPrCpx()+"  Cpx "+techf.Cpx+"  techf.lambda "+techf.lambda+"  techf.mu "+techf.mu);

            hlc=Util.aff_d(hc,getPrecision(hc));
            hlf=Util.aff_d(hf,getPrecision(hf));
        	JLabhlc.setText(resIntTh_fr.getString("hlc")+" = "+Util.aff_d(hc,getPrecision(hc))+" Re = "+Util.aff_d(techc.Re,getPrecision(techc.Re)));
            JLabhlf.setText(resIntTh_fr.getString("hlf")+" = "+Util.aff_d(hf,getPrecision(hf))+" Re = "+Util.aff_d(techf.Re,getPrecision(techf.Re)));
        }
        return u;
    }

    public double getUlv(double xc,double xf){
        double u=1;
        if((techc!=null)&&(techf!=null)){
        //    calcNusselt((Tcl+Tcv)/2., (Tfl+Tfv)/2., Pce, Pfe, xc, xf, mCpcl/mc, mCpfl/mf, false,true);
            techc.calcNusselt((Tcl+Tcv)/2., techc.amont.P, xc, mCpcl/mc, false,true);
            techf.calcNusselt((Tfl+Tfv)/2., techf.amont.P, xf, mCpfl/mf, false,true);
            u=get_U();
            hlvc=Util.aff_d(hc,getPrecision(hc));
            hlvf=Util.aff_d(hf,getPrecision(hf));
            JLabhlvc.setText(resIntTh_fr.getString("hlvc")+" = "+Util.aff_d(hc,getPrecision(hc))+" Re = "+Util.aff_d(techc.Re,getPrecision(techc.Re)));
            JLabhlvf.setText(resIntTh_fr.getString("hlvf")+" = "+Util.aff_d(hf,getPrecision(hf))+" Re = "+Util.aff_d(techf.Re,getPrecision(techf.Re)));
        }
        return u;
    }
    public void setupA(boolean changesA){//calcule le A global et met  jour le TechnoHx
        Av=1000.*UAv/Uv;
        Al=1000.*UAl/Ul;
        Alv=1000.*UAlv/Ulv;
        A=Av+Alv+Al;
        setupA(changesA,A,Ul,Al,Ulv,Alv,Uv,Av);
        JLabhlvc.setText(JLabhlvc.getText()+" Alv = "+Util.aff_d(Alv,getPrecision(Alv)));
       	JLabhlc.setText(JLabhlc.getText()+" Al = "+Util.aff_d(Al,getPrecision(Al)));
        JLabhvc.setText(JLabhvc.getText()+" Av = "+Util.aff_d(Av,getPrecision(Av)));
        JLabhlvf.setText(JLabhlvf.getText()+" UAlv = "+Util.aff_d(UAlv,getPrecision(UAlv)));
       	JLabhlf.setText(JLabhlf.getText()+" UAl = "+Util.aff_d(UAl,getPrecision(UAl)));
        JLabhvf.setText(JLabhvf.getText()+" UAv = "+Util.aff_d(UAv,getPrecision(UAv)));

    }
    
    int getPrecision(double value) {
	    	int n = (int)value ; 
	    	int num = String.valueOf(n).length(); 
	    	int prec =0;
	    	if(num<=3) prec = 4-num;
	    	return prec;
    	} 
    	
	public void calcNUsselt(){// calcul de base pour un changeur en sensible (non 3 steps)
	    techc.calcNUsselt();
	    techf.calcNUsselt();
	}

	public void makeDesign(){
	    resetHX();
	    makesDesign=true;
	    techc.calcNUsselt();
	    techf.calcNUsselt();
//        System.out.println("entr makeDesign() ");

	    if(techc.mu*techf.mu*techc.lambda*techf.lambda!=0){
 //           System.out.println("pass mu lambda ");

            double fin_c=Util.lit_d(techc.FA_value.getText())*Util.lit_d(techc.etaF_value.getText());
            double fin_f=Util.lit_d(techf.FA_value.getText())*Util.lit_d(techf.etaF_value.getText());
            double Nuc=techc.Nu;
            double Nuf=techf.Nu;
            double hc=techc.lambda*techc.Nu*fin_c/Util.lit_d(techc.Dh_value.getText());
            JLabhvc.setText(resIntTh_fr.getString("hc")+" = "+Util.aff_d(hc,2)+"  Re = "+Util.aff_d(techc.getRe(),2));
            double hf=techf.lambda*techf.Nu*fin_f/Util.lit_d(techf.Dh_value.getText());
            JLabhvf.setText(resIntTh_fr.getString("hf")+" = "+Util.aff_d(hf,2)+"  Re = "+Util.aff_d(techf.getRe(),2));
	            
//	            U=1./(techc.Dh_value.getValue()/techc.lambda/techc.Nu/fin_c+techf.Dh_value.getValue()/techf.lambda/techf.Nu/fin_f);
	        U=1./(1./hc+1./hf+Util.lit_d(eLambda_value.getText()));
	        displayU();
	        double A=UA/U*1000.;//UA en kW/K
	        ADesign_value.setText(Util.aff_d(A,4));
	        A_value.setText(Util.aff_d(A));
	    /*      double Lc=A/Ac_c_value.getValue()*Dhc_value.getValue()/2.;
	        double Lf=A/Ac_f_value.getValue()*Dhf_value.getValue()/2.;
	        if(debug)System.out.println("Lc "+Lc+"  Lf "+Lf);*/
	    }
	    calcPressureDrops(false);
	    makesDesign=false;
	}
	public void displayU(){
		U_value.setVisible(true);
	    U_value.setText(Util.aff_d(U,4));
		JLabel5.setText("average U");
//		JPanel1.repaint();
	}
	
	public double getU(){
	    return U;
	}

	public double getA(){
	    return A;
	}
	public double getAl(){
	    return Al;
	}
	
	public double getAlv(){
	    return Alv;
	}
	
	public double getAv(){
	    return Av;
	}
/*
 * Dtermine le U global une fois que les te.Nu ont t calculs
 * Tient compte des ailettes et de la rsistance de paroi
 * Mthode gnrique pour toutes les zones de l'changeur
 *	 hc=techc.lambda*techc.Nu/techc.Dh_value.getValue();
 *	 hf=techf.lambda*techf.Nu/techf.Dh_value.getValue();
 */
	public double get_U(){//calcul de U avec prise en compte des facteurs d'amplification de surface ( creuser)
	    if(techc.mu*techf.mu*techc.lambda*techf.lambda!=0){
	    	techc.calcH();
	        hc=techc.getH();//modRG 20/03
	        techf.calcH();
	        hf=techf.getH();
	        if(debug)System.out.println(" calcul h :hc "+hc+"  hf "+hf+" corps c "+techc.corps.name+" corps f "+techf.corps.name);
	        if(debug)System.out.println("techc.mu "+techc.mu+"  techc.lambda "+techc.lambda+"  techc.Pr "+techc.getPr());
	        if(debug)System.out.println("techf.mu "+techf.mu+"  techf.lambda "+techf.lambda+"  techf.Pr "+techf.getPr());
	        
            double fin_c=Util.lit_d(techc.FA_value.getText())*Util.lit_d(techc.etaF_value.getText());
            double fin_f=Util.lit_d(techf.FA_value.getText())*Util.lit_d(techf.etaF_value.getText());
    	            
//	        return fin_f/(fin_f/fin_c/hc+1/hf);
	        return 1/(1/fin_c/hc+1/fin_f/hf+Util.lit_d(eLambda_value.getText()));
	        
//	        return techf.FA_value.getValue()/(techf.FA_value.getValue()/techc.FA_value.getValue()/hc+1/hf);
	    }
	    return 1.;
	}
	
    public void setupA(boolean changesA, double A, double Ul, double Al, double Ulv, double Alv, double Uv, double Av){
        //met  jour l'cran du TechnoHx et crit dans output.txt
        JLabUl.setText("Ul = "+Util.aff_d(Ul,2));
        JLabUlv.setText("Ulv = "+Util.aff_d(Ulv,2));
        JLabUv.setText("Uv = "+Util.aff_d(Uv,2));
        JLabAl.setText("Al = "+Util.aff_d(Al,2));
        JLabAlv.setText("Alv = "+Util.aff_d(Alv,2));
        JLabAv.setText("Av = "+Util.aff_d(Av,2));
        if(changesA)ADesign_value.setText(Util.aff_d(A,5));
        
        if(debug)System.out.println("");
        if(debug)System.out.println("changeur "+hXname);
        if(debug)System.out.println("Ul : "+Ul+"  Ulv : "+Ulv+"  Uv : "+Uv);
    //   System.out.println("Tfs : "+hX.Tfs+"  Tfv : "+hX.Tfv+"  Tfl : "+hX.Tfl+"  Tfe : "+hX.Tfe);
        if(debug)System.out.println("Al : "+Al+"  Alv : "+Alv+"  Av : "+Av);
        if(debug)System.out.println("");
    }
    
    public void calcPressureDrops(boolean calcNusselt){
        techc.calcPressureDrop(calcNusselt);
        techf.calcPressureDrop(calcNusselt);
    }

    public void calcHx(){
  	    if(techc.mu*techf.mu*techc.lambda*techf.lambda!=0){
	        //On commence par valuer U  partir des TechnoExch chaud et froid
	        U=1./(Util.lit_d(techc.Dh_value.getText())/techc.lambda/techc.Nu+
	        Util.lit_d(techf.Dh_value.getText())/techf.lambda/techf.Nu
	        +Util.lit_d(eLambda_value.getText()));
	        U_value.setText(Util.aff_d(U));
	        if(Util.lit_d(A_value.getText())!=0){
	            UA=U*Util.lit_d(A_value.getText())/1000.;//UA en kW/K
	          
	            //  hX.UA_value.setValue(hX.UA);//modRG 12/11
	            //On repasse ensuite la main  HeatExDemo pour le recalcul de l'changeur
    	                
    //	                hX.reCalcMonozone();
    	                
	        /*      if(testeHx()==0)hX.reCalcMonozone();
	            else if(testeHx()==1)calcHxElvHot();
	            else if(testeHx()==2)calcHxElvCold();*/
        	            
	        }
	        else{
	            String msg = "Watch out!: the heat exchanger area equals 0.";
	          //modRG	            JOptionPane.showMessageDialog(tde, msg);  
	        }
	    }
  }

	public void Calculate(){
        UA1_value.setText(Util.aff_d(0.));
        UA2_value.setText(Util.aff_d(0.));
	    calcNUsselt();//modRG 13_05
	    calcHx();
	}
	
/**
* generic inversion function called by Util.dicho_T
 * fonction gnrique appele par Util.dicho_T
 * @return double
 * @param $T double (temprature)
 * @param $p double (pression)
 * @param $fonct java.lang.String (code de  la fonction appele)
 */
public double f_dicho(double $T,double $p, String $fonct) {
 //   double reste=0;
    if ($fonct.equals("cas1")){
        return UA-UA1-UA2;
    }
    else if ($fonct.equals("cas2")){
        return UA-UA1-UA2;
    }
    else{
    	//modRG	    JOptionPane.showMessageDialog(tde,"function in f_dicho TechnoHx does not exist: "+$fonct);
        return 0;
    }
}

	/**
	 * reads project file specific technoDesign data
	 */
	public void readCaract(String ligne_data){
//	    super.readCaract(ligne_data);
        String value=Util.extr_value2(ligne_data, "3steps");
	    if(!(value==null))isThreeStep=Util.lit_b(value);
//        setupTechHx();
        value=Util.extr_value2(ligne_data, "ADesign_value");
		if(!(value==null))ADesign_value.setText(value);
//		System.out.println(ligne_data);
		readSpecificParams(ligne_data);
//	    value=Util.extr_value2(ligne_data, ":qlv");
//		if(!(value==null)){
//		    qlv=Util.lit_d(value);
//	    }
//		System.out.println("pass dans readCaract "+qlv);

		techc.readCaract(Util.extr_value4(ligne_data,"confHot"));
		techf.readCaract(Util.extr_value4(ligne_data,"confCold"));
	    
	}
	
/*	public void readCompParameters(String ligne_data){
		StringTokenizer st= new StringTokenizer(ligne_data,"\n");
       String value=Util.extr_value(ligne_data, "ADesign_value");
		if(!(value==null))ADesign_value.setText(value);
		value=Util.extr_value(ligne_data, "eLambda");
		if(!(value==null))eLambda_value.setText(value);
	    String ligne = st.nextToken();
 		ligne = st.nextToken();
		techc.readCompParameters(ligne);
		ligne = st.nextToken();
		techf.readCompParameters(ligne);
	    
	}*/
	public void readCompParameters(String ligne_data){
		StringTokenizer st= new StringTokenizer(ligne_data,"\n");
	    String ligne = st.nextToken();
        String value=Util.extr_value(ligne, "ADesign_value");
		if(!(value==null))ADesign_value.setText(value);
		value=Util.extr_value(ligne, "eLambda");
		if(!(value==null))eLambda_value.setText(value);
		value=Util.extr_value(ligne, "qlv");
		if(!(value==null))qlv=Util.lit_d(value);
//		System.out.println("pass dans readCompParameters");
        
		ligne = st.nextToken();
		techc.readCompParameters(ligne);
		ligne = st.nextToken();
		techf.readCompParameters(ligne);
	    
	}

	public void setNutCorrel(String correlationName){}
	public void setPdcCorrel(String correlationName){}
	
	public String saveSpecificParams(){
		return "";
	}
	public void readSpecificParams(String ligne_data){
	
	}

	/**
	 * saves project file specific technoDesign data
	 */
    public String saveCaract(){
	    String h="3steps="+Util.aff_b(isThreeStep)+":"
        +"ADesign_value="+ADesign_value.getText()+":"
 //       +"qlv="+qlv+":"
        +"@confHot="+techc.saveCaract()+":"
        +"@confCold="+techf.saveCaract()+":"
        ;
        
        return h;
    }
    public String saveCompParameters(){
	    String h="ADesign_value="+ADesign_value.getText()+"\teLambda="+eLambda_value.getText()+"\tqlv="+qlv
	    		+saveSpecificParams()+"\n"
        +techc.saveCompParameters()+"\n"
        +techf.saveCompParameters()+"\n"//retour  la ligne impratif (les deux prcdents sont spcifiques des changeurs)
        ;
        
        return h;
    }
    
	
}