/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.awt.Font;
import java.lang.reflect.Constructor;
import java.util.Vector;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import extThopt.AirExchangerDriver.SymAction;
import extThopt.TechnoExch.SymItem;
import rg.thopt.*;


public class TechnoSteamGenerator extends TechnoEvaporator
{
//	double P_cv, P_cl, P_cs, P_fs, P_fv, P_fl, P_fe, Psat, Tsat, Pf_inlet, Pc_inlet, Tf_inlet, Tc_inlet;
//	double dPSing, dPf_l, dPf_lv, dPf_v, dPc_l, dPc_lv, dPc_v;
	final boolean UPDATE_T=true,UPDATE_P=true,UPDATE_X=true;
	
	public TechnoSteamGenerator()
	{
        super();
    }
	public TechnoSteamGenerator(Projet proj, String hXname, PointThopt amontHot, PointThopt avalHot, PointThopt amontCold, PointThopt avalCold)
	{
	    super(proj, hXname, amontHot, avalHot, amontCold, avalCold);
	    corps=new CorpsThopt(proj, amontCold.nomCorps, amontCold.lecorps);
    //	debug=true;
	    Al=300;Alv=2100;Av=400;
	    A=Al+Alv+Av;
	    
		JLabel6.setText("nb. iter.");
		JPanel1.add(JLabel6);
		JLabel6.setForeground(new java.awt.Color(102,102,153));
		JLabel6.setBounds(244,52,96,24);
		JPanel1.add(A_value);
		A_value.setBounds(340,52,104,24);
		A_value.setText("6");
		JLabel11.setText("UA1");
//		JPanel1.add(JLabel11);
		JLabel11.setBounds(244,84,96,24);
		nutCorrelChoice.setBounds(244,100,168,24);		
		nutCorrelLabel.setText("NTU correlation");
		nutCorrelLabel.setBounds(244,76,200,24);
		nutCorrelLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		nutCorrelLabel.setForeground(new java.awt.Color(102,102,153));


		JPanel1.add(pdcCorrelChoice);
		pdcCorrelChoice.setBounds(244,148,168,24);
		JPanel1.add(pdcCorrelLabel);
		pdcCorrelLabel.setText("Pressure drop correlation");
		pdcCorrelLabel.setBounds(244,124,200,24);
		pdcCorrelLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		pdcCorrelLabel.setForeground(new java.awt.Color(102,102,153));
   
		nutCorrelChoice.addItemListener(lSymItem);
		pdcCorrelChoice.addItemListener(lSymItem);
		nutCorrelationName="Saitoh & al.";
        pdcCorrelationName="Sun & Mishima";
        
        nutCorrelChoice.addItem("Saitoh & al.");
        nutCorrelChoice.addItem("Borishanskiy & al.");
        nutCorrelChoice.addItem("Shah");
        nutCorrelChoice.addItem("Kandlikar");
        nutCorrelChoice.addItem("Gungor Winterton");
        nutCorrelChoice.addItem("Kim & Mudawar");
        nutCorrelChoice.setSelectedIndex(0);
         
        pdcCorrelChoice.addItem("Sun & Mishima");
        pdcCorrelChoice.addItem("Mller-Steinhagen & Heck");
        pdcCorrelChoice.addItem("Friedel");
        pdcCorrelChoice.addItem("Lockhart-Martinelli");
        
        type=getType();
    }
	
//	SymAction lSymAction = new SymAction();
	SymItem lSymItem = new SymItem();
	
	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == nutCorrelChoice)
				nutCorrelChoice_itemStateChanged(event);
			else if (object == pdcCorrelChoice){				
				pdcCorrelChoice_itemStateChanged(event);
			}

		}
	}

	void nutCorrelChoice_itemStateChanged(java.awt.event.ItemEvent event){
		nutCorrelationName=(String) nutCorrelChoice.getSelectedItem();
	}
	void pdcCorrelChoice_itemStateChanged(java.awt.event.ItemEvent event){
		pdcCorrelationName=(String) pdcCorrelChoice.getSelectedItem();
	}



	javax.swing.JComboBox nutCorrelChoice= new javax.swing.JComboBox();
	javax.swing.JComboBox pdcCorrelChoice= new javax.swing.JComboBox();
	javax.swing.JLabel nutCorrelLabel= new javax.swing.JLabel();
	javax.swing.JLabel pdcCorrelLabel= new javax.swing.JLabel();
	

	public TechnoSteamGenerator(Projet proj, String hXname)
	{
	    super(proj, hXname);
	    corps=new CorpsThopt(proj, techf.amont.nomCorps, techf.amont.lecorps);
   // 	debug=true;

    }
  	public String getClassDescription(){
	    return "Steam generator class\n\nauthor : R. Gicquel  december 2020\n\nRef : archive ";
	}
	
    public String getType(){
        return "Steam generator";
    }
    public String getCompType(){
        return "Steam generator";
    }
    public String getClassName(){
        return "TechnoSteamGenerator";
    }
 /*
  * Calcule la perte de charge rgulire monophasique
  */
	public double calcDP(double vl, TechnoExch te){
	    double dP;
	    double flow=te.getFlow();
	    double Ac=Util.lit_d(te.Ac_value.getText());
	    double dh=Util.lit_d(te.Dh_value.getText());
	    double L=Util.lit_d(te.L_value.getText());
	    double Re=flow/Ac/te.mu*Util.lit_d(te.Dh_value.getText());//nombre de Reynolds

	    double f=te.fc.getFrictionFactor(Re);
	    double C=flow*vl/Ac;
	    te.frictionFactor_value.setText(Util.aff_d(f,6));
	    if(debug)System.out.println("TechnoCSG "+"\tRe\t"+Re+"\tdh\t"+dh+"\tf\t"+f);
	    dP=f*vl/2*flow*flow/Ac/Ac*L/dh/100000;//Perte rgulire en bar
	    return dP;
    }
	
	 /*
	  * Calcule la perte de charge complte
	  */
	void calcPressureDrops(){
		//Le choix de la corrlation de perte de charge tant gr directement
		//on masque la ComboBox du FlowConfig
		techf.sf.maskPdcCorrel();
		techc.sf.maskPdcCorrel();
		
	      //perte de charge singulire ct froid
		    double vl=1/(1/techf.amont.V+1/techf.aval.V);
		    vl=techf.amont.V;
		    double flow=techf.getFlow();
		    double Ac=Util.lit_d(techf.Ac_value.getText());
		    dPSing=Util.lit_d(techf.dPSingKcoeff_value.getText())*vl/2*flow*flow/Ac/Ac/100000;//Perte singulire en bar
		    techf.dP_Sing_value.setText(Util.aff_d(dPSing,6));
	        
	        //pertes de charge rgulires ( recalculer aux bonnes valeurs de coupure P,T)
	        techf.initLambdaMu(techf.amont.T,  techf.amont.P, 0);
	        techc.initLambdaMu(techc.amont.T,  techc.amont.P, 0);
	        double dP_c=calcDP(techc.amont.V, techc);
	        double dP_f=calcDP(techf.amont.V, techf);
	        if(debug)System.out.println("TechnoCSG "+"\tdPSing\t"+dPSing+"\tdP_c\t"+dP_c+"\tdP_f\t"+dP_f);
	        
		    //calcul par rapport aux valeurs moyennes
		    vl=1/(1/techf.amont.V+1/techf.aval.V);
	        techf.initLambdaMu((techf.amont.T+techf.aval.T)/2,  techf.amont.P, 0);
	        dP_f=calcDP(vl, techf);
	        if(debug)System.out.println("TechnoCSG moyen"+"\tdPSing\t"+dPSing+"\tdP_c\t"+dP_c+"\tdP_f\t"+dP_f);

		    //Initialisations
	        Tsat=techf.corps.lecorps.getSatTemperature(techf.amont.P, 0);//pression d'vaporation
		    techf.corps.lecorps.CalcPropCorps(Tsat+0.1,techf.amont.P,0);
		    Vector vProp=techf.corps.lecorps.getSubstProperties();
	        Double f=(Double)vProp.elementAt(3);
	        double v=f.doubleValue();
	        double ro_v=1/v;
		    techf.corps.lecorps.CalcPropCorps(Tsat-0.1,techf.amont.P,0);
		    vProp=techf.corps.lecorps.getSubstProperties();
	        f=(Double)vProp.elementAt(3);
	        v=f.doubleValue();
	        double ro_l=1/v;
	        techf.initLambdaMu(Tsat, techf.amont.P, 0);
	        double mu_l=techf.mu;
	        double sigma=techf.sigma;
		    techf.initLambdaMu(Tsat, techf.amont.P, 1);
	        double mu_v=techf.mu;
		    //vitesse massique
		    double G= techf.getFlow()/Util.lit_d(techf.Ac_value.getText());

		    //nombre de Reynolds
		    double Re_v=G/techf.mu_g*Util.lit_d(techf.Dh_value.getText());

		    //Corrlation de Lockart-Martinelli
		    double F=0;
		    double F_LM=0;
		    double Xtt=0;
		    double F_fr=0;
			double mu=Math.pow(techf.mu_l/techf.mu_g, -0.1);
			double ro=Math.pow(ro_l/ro_v, 0.5);
			for(int i=0;i<100;i++){
				double x=i/100.;
				Xtt=Math.pow((1-x)/x, 0.9)/ro/mu;
				double ff=Math.pow(1-x, 1.8)*(1+20/Xtt+1/Xtt/Xtt);
				F_LM=F_LM+ff*0.01;
			}
			System.out.println("Corrlation de Lockart-Martinelli TA\t"+"\tF_LM\t"+F_LM);		
	
			//Corrlation de Sun et Mishima
			double F_SM=0;
		    double X22=0;
		    double Re_l=G/techf.mu_l*Util.lit_d(techf.Dh_value.getText());//nombre de Reynolds
		    double f_la=getMishimaFrictionFactor(Re_l);

		    double dPz_la=f_la/2*G*G/ro_l/Util.lit_d(techf.Dh_value.getText())/100000;

			for(int i=1;i<100;i++){
				double x=i/100.;
			    double Re_lo=G*(1-x)/techf.mu_l*Util.lit_d(techf.Dh_value.getText());//nombre de Reynolds
			    double f_lo=getMishimaFrictionFactor(Re_lo);
			    double Re_go=G*x/techf.mu_g*Util.lit_d(techf.Dh_value.getText());//nombre de Reynolds
			    double f_go=getMishimaFrictionFactor(Re_go);
			    //Attention : f est exprim de manire homogne avec les autres corrlations 
			    //par des valeurs 4 fois plus importantes que dans Thome et Cioncolini
			    double dPz_lo=f_lo/2*G*G*(1-x)*(1-x)/ro_l/Util.lit_d(techf.Dh_value.getText())/100000;
			    X22=Math.pow(f_lo/f_go, 0.5)*(1-x)/x/ro;
				double C=1.79*Math.pow(X22,-0.19)*Math.pow(1/x-1, 0.1)*Math.pow(techf.mu_l/techf.mu_g,0.4);
				double ff=1+C/X22+1/X22/X22;
				F_SM=F_SM+dPz_lo*ff/99./dPz_la;
//				F_SM=F_SM+dPz_lo*ff/99.;
			}			
			System.out.println("Corrlation de Sun et Mishima\t"+"\tF_SM\t"+F_SM);
						
			//Corrlation de Mller-Steinhagen and Heck
			
		    f_la=getMSHFrictionFactor(Re_l);
		    double f_va=getMSHFrictionFactor(Re_v);
		    double L=Util.lit_d(techf.L_value.getText());

		    dPz_la=f_la/2*G*G/ro_l/Util.lit_d(techf.Dh_value.getText())/100000;
		    double dPz_va=f_va/2*G*G/ro_v/Util.lit_d(techf.Dh_value.getText())/100000;
		    
		    double dPz=0;
			for(int i=0;i<100;i++){
				double x=i/100.;
				double ff=(dPz_la+2*(dPz_va-dPz_la)*x)*Math.pow(1-x, 1./3.)+dPz_va*Math.pow(x, 3.);
				dPz=dPz+ff*0.01;
			}
			double F_MSH=dPz/dPz_la;

			System.out.println("Corrlation de Mller-Steinhagen and Heck\t"+"\tF\t"+F_MSH);

			//Corrlation de Friedel
			
		    f_la=getMSHFrictionFactor(Re_l);			
		    dPz_la=f_la/2*G*G/ro_l/Util.lit_d(techf.Dh_value.getText())/100000;
		    dPz=0;
			for(int i=0;i<100;i++){
				double x=i/100.;
				    double A1=(1-x)*(1-x)+x*x*ro_l/ro_v*f_va/f_la;
			    double A2=Math.pow(x,0.78)*Math.pow(1-x,0.224);
			    double A3=Math.pow(ro_l/ro_v,0.91)*Math.pow(mu_v/mu_l,0.19)*Math.pow(1-mu_v/mu_l,0.7);

			    double ro_h=1/((1-x)/ro_l+x/ro_v);
			    double Fr=G*G/ro_h/ro_h/9.81/Util.lit_d(techf.Dh_value.getText());
			    double We=G*G*Util.lit_d(techf.Dh_value.getText())/ro_h/sigma;
			    double phi2_la=A1+3.24*A2*A3/Math.pow(Fr,0.045)/Math.pow(We,0.035);
				dPz=dPz+phi2_la*dPz_la*0.01;
			}
			
		    F_fr=dPz/dPz_la;
			double dPl=dPz_la*L;
			double dPv=dPz_va*L;
			if(debug)System.out.println("dPz_la\t"+dPz_la+"\tdPz_va\t"+dPz_va+"\tF_MSH\t"+F_MSH
					+"\tdPl\t"+dPl+"\tdPv\t"+dPv);
			System.out.println("Corrlation de Friedel\t"+"\tF\t"+F_fr);
			
			//choix du facteur multiplicatif en fonction de la corrlation retenue
			if(pdcCorrelationName.equals("Sun & Mishima"))F=F_SM;
			else if(pdcCorrelationName.equals("Mller-Steinhagen & Heck"))F=F_MSH;
			else if(pdcCorrelationName.equals("Lockhart-Martinelli"))F=F_LM;
			else if(pdcCorrelationName.equals("Friedel"))F=F_fr;

		    double dPlv=F*dP_f;
		    dPl=calcDP(techf.amont.V, techf);
		    dPv=calcDP(techf.aval.V, techf);

		    dPf_l=Al/A*dPl;
		    dPf_lv=Alv/A*dPlv;
		    dPf_v=Av/A*dPv;
		    dP_f=dPf_l+dPf_lv+dPf_v;
		    
		    dPc_l=Al/A*dP_c;
		    dPc_lv=Alv/A*dP_c;
		    dPc_v=Av/A*dP_c;
		    
		    if(debug)System.out.println("TechnoCSG dPl\t"+dPl+"\tdPv\t"+dPv+"\tdPlv\t"+dPlv+"\tdP_f\t"+dP_f);	        
		    
		    techc.dP_value.setText(Util.aff_d(dP_c,6));
		    techf.dP_value.setText(Util.aff_d(dP_f+dPSing,6));
		    
	}

	public double getMishimaFrictionFactor(double Re){
	    if(Re>2000){
	    	return 0.314*Math.pow(Re,-0.25);
	    }
	    else{
	        return 64/Re;
	    }

    }
	/*	public double getMSHFrictionFactor(double Re){
    if(Re>1187)return 0.0791*Math.pow(Re,-0.25);
    else return 16/Re;
}*/
/* Version alternative de la formule de Blasius
 * exprime de manire homogne avec getFrictionFactor
 * (ce qui explique le facteur 4 par rapport aux publications)
 */

public double getMSHFrictionFactor(double Re){
    if(Re>1187)return 0.316*Math.pow(Re,-0.25);
    else return 64/Re;
}


    public void makeDesign(){//chaud en sensible, froid diphasique (vaporateur)
   
    	techf.amont.getProperties();
    	techc.amont.getProperties();
        
        calcPressureDrops();      
 //       if(Psat==0)Psat=techf.amont.P;

        
        //Notations de la figure 1 de la note explicative
        //Les pressions sont mises  jour en fonction des pertes de charge
        Pf_inlet=techf.amont.P;
        P_fe=Pf_inlet-dPSing;
        P_fl=P_fe-dPf_l;
        P_fv=P_fl-dPf_lv;
        P_fs=P_fv-dPf_v;

        Pc_inlet=techc.amont.P;
        P_cv=Pc_inlet-dPc_v;
        P_cl=P_cv-dPc_lv;
        P_cs=P_cl-dPc_l;
        
	    Tf_inlet=techf.amont.T;
	    Tc_inlet=techc.amont.T;

	    if(debug)System.out.println("Pf_inlet\t"+Pf_inlet+"\tP_fe\t"+P_fe+"\tP_fl-Psat\t"+Psat+"\tP_fv\t"+P_fv+"\tP_fs\t"+P_fs
        		+"\nPc_inlet\t"+Pc_inlet+"\t P_cv\t"+P_cv+"\t P_cl\t"+P_cl+"\tP_cs\t"+P_cs);

        //Mise  jour des tats de sortie
        avalCold.P=P_fs;
        avalCold.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
        avalCold.getProperties();
        
        avalHot.P=P_cs;
        avalHot.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
        avalHot.getProperties();

        //Recalcul de l'changeur, 
        
        //attention, en principe le primaire ne devrait pas changer
        //cela fournit un nouveau Tfs
        
        for (int i=0;i<10;i++)resetHX();
        
        Tcs=techc.aval.T;
        Tfs=techf.aval.T;
         
        //calcul de mCpflv,  Tsat, Psat
        Psat=P_fl;
        Tsat=corps.lecorps.getSatTemperature(Psat,0);
        Tfl=Tsat;
	    corps.lecorps.CalcPropCorps(Tsat-0.1, Psat, 0);
	    corps.getSubstProperties();
	    corps.lecorps.CalcPropCorps(Tsat-0.01, Psat, 0);
	    corps.getSubstProperties();
        double Hl=corps.H;
	    corps.lecorps.CalcPropCorps(Tsat+0.01, Psat, 1);
	    corps.getSubstProperties();
        double Hv=corps.H;
        Lf=Hv-Hl;
        mCpflv=mf*Lf;   

        //calcul de mCpfv, moyenne entre Tfv, Pfv et Tfs, Pfs  
	    corps.lecorps.CalcPropCorps(Tfs, P_fs, 1);
	    corps.getSubstProperties();
	    Hv=corps.H; 
	    //recalcul de Tfv correspondant au laminage en sortie de vaporiseur
//	    corps.lecorps.CalcPropCorps(Tsat, P_fv, 1);
	    corps.lecorps.CalcPropCorps(Tsat+0.01, Psat, 1);//modRG 12/2021
	    corps.getSubstProperties();
	    double h=corps.H; 
	    Tfv=corps.lecorps.inv_hp_T(h, P_fv);
//	    System.out.println("pass 2 ");
	    corps.lecorps.CalcPropCorps(Tfv, P_fv, 1);
	    corps.getSubstProperties();
        mCpfv=mf*(corps.H-Hv)/(Tfv-Tfs);
        
	    //recalcul de Tfe correspondant au laminage en sortie de diaphragme
	    corps.lecorps.CalcPropCorps(Tf_inlet, Pf_inlet, 1);
	    corps.getSubstProperties();
	    h=corps.H; //h  l'entre de l'changeur
	    Tfe=corps.lecorps.inv_hp_T(h, P_fe);

        //calcul de mCpfl, moyenne entre Tsat, Psat et Tf_inlet, Pf_inlet            
//	    corps.lecorps.CalcPropCorps(Tfe, P_fe, 0);
//	    corps.getSubstProperties();
        mCpfl=mf*(Hl-h)/(Tsat-0.01-Tfe);
        if(debug)System.out.println("Tfv "+Tfv+" Tsat "+Tsat+" Psat "+Psat+"  Tfe "+Tfe+" Tf_inlet "+Tf_inlet);
        
        //il vaudrait mieux calculer les 3 mCpc
	    Tc_inlet=techc.amont.T;
	   // techc.amont.   ;//   .corps.lecorps.CalcPropCorps(Tc_inlet, Pc_inlet, 0);
	   // techc.corps.getSubstProperties();
	    Hl=techc.amont.H;
	//    techc.corps.lecorps.CalcPropCorps(Tcs, P_cs, 0);
	//    techc.corps.getSubstProperties();
	    if(debug)System.out.println("Hl "+Hl+" corps.H "+corps.H+" Tcs "+Tcs+"  P_cs "+P_cs+" mc "+mc);
        mCpc=mc*(Hl-techc.aval.H)/(techc.amont.T-techc.aval.T);

        mCpclv=mCpc;        
        mCpcv=mCpc;
        mCpcl=mCpc;        
        
        if(debug)System.out.println("TechnoCSG Tfl "+Tfl+"  mCpc "+mCpc+" mCpfl "+mCpfl+" mCpflv "+mCpflv+" mCpfv "+mCpfv);
        if(debug)System.out.println("Hl "+Hl+"  Hv "+Hv+" Tfl "+Tfl+" Tfv "+Tfv+" Pf_inlet "+Pf_inlet);

        //Calcul du triple changeur
        Tcv=Tc_inlet-mCpfv/mCpc*(Tfs-Tfv);
        Tcl=Tcv-mCpflv/mCpc;
        Tcs=Tcl-mCpfl/mCpc*(Tfl-Tfe);
        DTmin=Tcl-Tfv;
        double tcl=Tcl-273.15;
        double tcv=Tcv-273.15;
        double tcs=Tcs-273.15;
        
        if(debug)System.out.println("TechnoCSG Tcl "+tcl+"  Tcv "+tcv+" Tcs "+tcs+" mCpflv "+mCpflv+" mCpfv "+mCpfv);
        
        //calcul des changeurs
            Rv=mCpfv/mCpc;
             if(Rv<=1){
            	 epsiv=(Tfs-Tfv)/(Tc_inlet-Tfv);
		        if((epsiv>0)&&(epsiv<1)){
		            NUTv=Util.NUT_epsi(epsiv,Rv);
		            UAv=mCpfv*NUTv;            	
		         }
		        else UAv=0;
           }
            else{
            	epsiv=(Tc_inlet-Tcv)/(Tc_inlet-Tfv);
            	Rv=mCpc/mCpfv;
		        if((epsiv>0)&&(epsiv<1)){
		            NUTv=Util.NUT_epsi(epsiv,Rv);
		            UAv=mCpc*NUTv;            	
		         }
		        else UAv=0;
           }
        epsilv=(Tcv-Tcl)/(Tcv-Tfv);
        if((epsilv>0)&&(epsilv<1)){
            Rlv=mCpc/mCpflv;
            NUTlv=Util.NUT_epsi(epsilv,Rlv);
            UAlv=mCpc*NUTlv;
        }
        else UAlv=0;
 //       epsil=(Tfv-Tfe)/(Tc_inlet-Tfe);
 /*       epsil=(Tfl-Tfe)/(Tcl-Tfe);
        if((epsil>0)&&(epsil<1)){
            Rl=mCpfl/mCpc;
            NUTl=Util.NUT_epsi(epsil,Rl);
            UAl=mCpfl*NUTl;
        }
        else UAl=0;*/
        Rl=mCpfl/mCpc;
        if(Rl<=1){
		 epsil=(Tfl-Tfe)/(Tcl-Tfe);
		if((epsil>0)&&(epsil<1)){
			Rl=mCpfl/mCpc;
			NUTl=Util.NUT_epsi(epsil,Rl);
			UAl=mCpfl*NUTl;
		}
		else UAl=0;
      }
       else{
		 epsil=(Tcl-Tcs)/(Tcl-Tfe);
      	Rl=mCpc/mCpfl;
		if((epsil>0)&&(epsil<1)){
			NUTl=Util.NUT_epsi(epsil,Rl);
			UAl=mCpfl*NUTl;
		}
		else UAl=0;
      }
        if(debug)System.out.println("TechnoSteamGenerator ");
        
	    if(debug)System.out.println("epsiv "+epsiv+"  epsilv "+epsilv+"  epsil "+epsil);
	    if(debug)System.out.println("Rv "+Rv+"  Rlv "+Rlv+"  Rl "+Rl);
	    if(debug)System.out.println("NUTv "+NUTv+"  NUTlv "+NUTlv+"  NUTl "+NUTl);
	    if(debug)System.out.println("UAv "+UAv+"  UAlv "+UAlv+"  UAl "+UAl);
	    if(debug)System.out.println("Tcv "+Tcv+"  Tcl "+Tcl+"  Tfv "+Tfv);
        UA=UAv+UAlv+UAl;
  //      UA_value.setValue(UA);
        Uv=getUv(techc.amont.X,1);
        Ulv=getUlv(techc.amont.X,0);
        Ul=getUl(techc.amont.X,0);
        setupA(true);
 //       calcPressureDrops(false);
        U=1000.*UA/A;
        qlv=mCpc*(Tcv-Tcl)/Alv;//*1000;
        ql=mCpfl*(Tfl-Tfe)/Al;//*1000;
        ql=mCpc*(Tcl-Tcs)/Al;//*1000;
  //      qlv=mCpc*(Tc_inlet-Tcs)/Alv*1000; densit totale de flux
 	 //   if(debug)
        if(debug)System.out.println("TechnoEvap mCpc "+mCpc+"  qlv "+qlv+"  mCpflv "+mCpflv+"  mCpfv "+mCpfv
	    			+"  ql "+ql+"  mCpfl "+mCpfl+"  mCpfv "+mCpfv);
       firstIteration=false;
    }
    
    
    public double getUl(double xc,double xf){
        double u=1;
        if((techc!=null)&&(techf!=null)){
        //    calcNusselt((Tcl+Tcs)/2., (Tfl+Tfe)/2., Pf_inlet,Pf_inlet, xc, xf, mCpcl/mc, mCpfl/mf, false,false);
            techc.calcNusselt((Tcl+Tcs)/2., Pc_inlet, xc, mCpcl/mc, false,false);
  //          calcNusselt((Tcl+Tcs)/2., techc.amont.P, xc, mCpcl/mc,false, techc);
            calcNusseltUlf((Tfl+Tfe)/2., P_fe, xf, mCpfl/mf, false,techf);
            u=get_U();
  	 //       if(debug)
            if(debug)System.out.println("getUl TSG Tcmoyenne "+(Tcl+Tcs)/2.+"  techc.Re "+techc.Re+"  techc.lambda "+techc.lambda+"  techc.mu "+techc.mu);
    //    if(debug)System.out.println("techf.Pr vap "+techf.getPrCpx()+"  Cpx "+techf.Cpx+"  techf.lambda "+techf.lambda+"  techc.mu "+techc.mu);
            hlc=Util.aff_d(hc,2);
            hlf=Util.aff_d(hf,2);
        	JLabhlc.setText(resIntTh_fr.getString("hlc")+" = "+Util.aff_d(hc,getPrecision(hc))+" Re = "+Util.aff_d(techc.Re,getPrecision(techc.Re)));
            JLabhlf.setText(resIntTh_fr.getString("hlf")+" = "+Util.aff_d(hf,getPrecision(hf))+" Re = "+Util.aff_d(techf.Re,getPrecision(techf.Re)));
        }
        return u;
    }  


	public void calcNusseltUlf(double T, double P, double x, double Cp, 
	    boolean calcDP, TechnoExch te){
	    //T est la temprature moyenne du fluide 
	    //P est la pression du fluide 
	    //x est le titre  prendre en compte pour le calcul des proprits du fluide (lambda et mu)
	    //(x=0 signifie calcul  l'tat liquide, et x=1  l'tat gazeux)
	    //Cp est la capacit thermique massique spcifique
	    //  prendre en compte pour le calcul des proprits des fluides (lambda et mu)
	    //calcDP est true si le calcul de la perte de charge est effectu 
	    //(il n'est pour le moment valable que pour l'changeur en sensible)
	    //diph est true pour le calcul de Ulv dans un changeur 3 steps dclar "cond" ou "evap"
	    // il est false pour le calcul de Ul et Uv, auquel cas il est considr "int_tube" pour le moment
	    // Cette manire de faire pourrait tre amliore. Elle est ncessaire parce qu'un changeur
	    // 3 steps a le mme TechnoHx qu'un changeur normal, ce qui est susceptible d'voluer
		te.initLambdaMu(T, P, x);
	    if(te.mu*te.lambda!=0){
	    	te.calcG();//vitesse massique
	    	te.calcPr(Cp);//nombre de Prandtl Cp en kJ/kg/K
	    	te.calcRe();//nombre de Reynolds
	    	te.Nu=calcNuUlf(P);//le relais est pass  la FlowConfig
//	        double dP=fc.calcDP();
	        te.calcH();
	    }
	    else{//message : lambda ou mu du fluide inconnu
		    String message="The conductivity or the viscosity is zero for fluid: "+corps.name;
            message=message+"\nYou should check the corresponding external class";
            JOptionPane.showMessageDialog(new JFrame(),message);
	    }
	}
public double calcNuUlf(double P){//Implmentation avec bullition nucle
	double Tc=0;
	double Tf=0;
	double Tsat=Tfl;
	double tsat=Tsat-273.15;
	double NUT_fl=0;
    double hf2=1e4;
    double h_f=0;
    double h_c=0;
    double twall=0;
 
    double h_FDB=Util.lit_d(hlvf);
	  double q_pb=0;
	  int count=8;
	  count=Util.lit_i(A_value.getText());
	  double dTonb=0, q_onb=0, dTfdb=0, q_fdb=0, Bo=0, G=0, deltaT_nvg=0;
//		System.out.println("x\t"+"tf\t"+"tc\t"+"twall\t"+"dTonb\t"+"hf\t"+"dTfdb\t"+"q_ofb\t"+"deltaTsub\t");	

		  for(int i=0;i<100;i++){
			//l'changeur est dcoup en 100 parties et 
			// les diffrents quilibres sont calculs
			double x=i/99.;	
			Tc= Tcs+(Tcl-Tcs)*x;
			Tf= Tfe+(Tfl-Tfe)*x;
			
	        double tf=Tf-273.15;
	        double tc=Tc-273.15;
//		    System.out.println("pass i "+i+"  tf  "+tf+"  tc "+tc);
			
			//attention,  bien vrifier
		    techf.initLambdaMu(Tf,  P_fe, 0);
			double h_db=techf.fc.C1*Math.pow(techf.getRe(),techf.fc.a_Re)*Math.pow(techf.getPr(),techf.fc.b_Pr)/Util.lit_d(techf.Dh_value.getText())*techf.lambda;
		    techc.initLambdaMu(Tc, Pc_inlet, 0);
			h_c=techc.fc.C1*Math.pow(techc.getRe(),techc.fc.a_Re)*Math.pow(techc.getPr(),techc.fc.b_Pr)/Util.lit_d(techc.Dh_value.getText())*techc.lambda;

		        
			//Ecoulement liquide avec bullition locale
	        //retard de dTonb
	        double fp=Math.pow(Psat,1.156);
	        double exp2=Math.pow(Psat,0.0234)/2.16;
	        double dTonb_b=5./9*Math.pow(9.23*ql/1e4/fp,exp2);//Berles
//	        System.out.println("Berles "+"  dTonb "+dTonb);
	        double dTonb_jl=22.65*Math.pow(ql/1e6,0.25)*Math.exp(-P/62.);//Jens Lottes 7,8 C
//	        System.out.println("Jens Lottes "+"  dTonb "+dTonb);
	        double hL=h_db;//Nu_db/dh*lambda;
	 //       double fact2=1+techf.lambda*Lf*1000*(Tsat-Tf)/2/techf.getSurfaceTension(Tf)/Tsat/(1/techf.ro_g-1/techf.ro_l)/hL;
	        double fact2=1+techf.lambda*Lf*1000*(Tsat-Tf)/2/techf.sigma/Tsat/(1/techf.ro_g-1/techf.ro_l)/hL;
	        fact2=Math.pow(fact2, 0.5);
	        
	        //Kandlikar
//	        double dTonb_k=4.*techf.getSurfaceTension(Tf)*Tsat*(1/techf.ro_g-1/techf.ro_l)*hL/techf.lambda/Lf/1000*(1+fact2);	        
//	        q_onb=techf.lambda*Lf*1000/8/techf.getSurfaceTension(Tf)/Tsat/(1/techf.ro_g-1/techf.ro_l)*dTonb_k*dTonb_k;
	        double dTonb_k=4.*techf.sigma*Tsat*(1/techf.ro_g-1/techf.ro_l)*hL/techf.lambda/Lf/1000*(1+fact2);	        
	        q_onb=techf.lambda*Lf*1000/8/techf.sigma/Tsat/(1/techf.ro_g-1/techf.ro_l)*dTonb_k*dTonb_k;
	        
	        //On retient la corrlation de Thom
	        double dTonb_th=25.*Math.pow(ql/1e6,0.5)*Math.exp(-P/87.);//Thom 6,5 C
	        
	        //moyenne des valeurs
	        dTonb=(dTonb_b+dTonb_jl+dTonb_k+dTonb_th)/4.;
			//max des valeurs
	        dTonb=dTonb_b;
	        if(dTonb_jl>dTonb)dTonb=dTonb_jl;
	        if(dTonb_k>dTonb)dTonb=dTonb_k;
	        if(dTonb_th>dTonb)dTonb=dTonb_th;
	        
	        
	        
	        G=techf.getFlow()/Util.lit_d(techf.Ac_value.getText());
	        double Pe=techf.getRe()*techf.getPr();
	        double Re=techf.getRe();
	        double Pr=techf.getPr();
	        Bo=ql/G/Lf/1000;
	        
			//Kandlikar
			double f=1.58*Math.log(Re)-3.28;
			f=1/f/f;
			//Gnielinski
			double Nu_gni=(Re-1000)*Pr*f/2/(1.0+12.7*(Math.pow(Pr, 2./3)-1)*Math.pow(f/2, 0.5));
			
	 	    techf.corps.lecorps.CalcPropCorps(Tsat-0.1,P,0);
		    Vector vProp=techf.corps.lecorps.getSubstProperties();
		    Double ff=(Double)vProp.elementAt(5);
	        ff=(Double)vProp.elementAt(5);
	        double hl=ff.doubleValue();
			
			Pe=Pr*Re;
			double v=G/techf.ro_l;
			double dh=Util.lit_d(techf .Dh_value.getText());
			double lambda=techf.lambda;
			

			
	       //quations (8.61) et (8.62) Kandlikar
	        double q_int=q_fdb/1.4;
	        double deltaTsub=q_int-Math.pow(q_int, 0.3)/1058./Math.pow(G*Lf, -0.7);
	        deltaTsub=deltaTsub*dh/lambda/Nu_gni;
			
			//Ghione pour Cathare 11 C
		    double delta_ic1=5*ql*techf.Cpx*dh/lambda/455.;
	        if(Pe>36400)delta_ic1=delta_ic1/Math.pow(Pe/7e4,1.4);
	        double hl2=hl-delta_ic1;
	        int correlNumber=4;
	        if(hl2>0){//Attention, peut devenir ngatif
//		    if(false){//Attention, peut devenir ngatif
		        double T_nvg=techf.corps.lecorps.inv_hp_T(hl2, P);
		        deltaT_nvg=Tsat-T_nvg;
		        correlNumber=5;
	        }
	        else deltaT_nvg=0;
			//pour le calcul de h_nvg (quation (8.56) de Kandlikar)
			q_fdb=1058*Math.pow(Bo, 0.7)*Nu_gni/dh*lambda*deltaT_nvg;
//	        hf2=1058*Math.pow(Bo, 0.7)*Nu_gni/dh*lambda;
	        //rapporte  Delta Tw_f
//	        hf2=hf2*(Twall-Tsat)/(Twall-Tf);
			double dTfdb_sz=0;
			if(Pe>70000)dTfdb_sz=ql/G/techf.Cpx/0.0065;//Shah Zuber Pe>70 000   13,5 C
			else dTfdb_sz=ql*dh/lambda/455;//Shah Zuber Pe<70 000 2,19 C
			double dTfdb_u75=0.24*ql*dh/lambda/Nu_gni;//Unal 1975 1,21 C
			double dTfdb_u=ql*dh/lambda/Nu_gni*(1-Math.pow(0.92, 3));//Unal 1,125 C
			double dTfdb_b=(14.+0.1*P)*ql*techf.ro_l/G*1e-6;//OSV Bowring 13,79 C
			
			//moyenne des valeurs
			dTfdb=(deltaT_nvg+dTfdb_sz+dTfdb_u75+dTfdb_u+dTfdb_b)/correlNumber;
			//max des valeurs
			dTfdb=deltaT_nvg;
	        if(dTfdb_sz>dTfdb)dTfdb=dTfdb_sz;
	        if(dTfdb_u75>dTfdb)dTfdb=dTfdb_u75;
	        if(dTfdb_u>dTfdb)dTfdb=dTfdb_u;
	        if(dTfdb_b>dTfdb)dTfdb=dTfdb_b;
			
	        for(int j=count-1;j>=0;j--){					
//			    System.out.println("pass j "+j);
				//temprature de paroi
		        double Rt=1/hf2+Util.lit_d(techf.tHx.eLambda_value.getText())+1/h_c;
		        double Twall=Tc/hf2/Rt+(1-1/hf2/Rt)*Tf;		        
		        twall=Twall-273.15;	
//		        deltaTsub=Twall+(Tc-Tf)/Rt*Util.lit_d(techf.tHx.eLambda_value.getText())-273.15;

		        // l'ONB, le flux surfacique est le mme que le monophasique
		        double h_l2=ql/(Twall-Tf);
		        //au FDB le flux surfacique est gal  celui de l'bullition sature
				q_fdb=h_FDB*(Twall-Tf);

				if(Twall-Tsat>dTonb){//si Twall-Tsat est compris entre dTonb et dTOFB
					if(Twall-Tsat<dTfdb)
						hf2=h_FDB-(h_FDB-h_l2)/(dTfdb-dTonb)*(dTfdb-Twall+Tsat);
					else hf2=h_FDB;
					if(hf2<h_db)hf2=h_db;
				  	q_pb=q_pb+hf2/99/count*(Twall-Tsat);

				    techf.initLambdaMu(Tfe,  P_fe, 0);

				  	NUT_fl=NUT_fl+hf2/count*Util.lit_d(techf.Dh_value.getText())/techf.lambda/99.;
			        h_f=h_f+hf2/99/count;
		        }
				else{//pas d'bullition locale
				  	hf2=h_db;//pour le calcul de Tw
				    techf.initLambdaMu(Tfe,  P_fe, 0);

					NUT_fl=NUT_fl+h_db/count*Util.lit_d(techf.Dh_value.getText())/techf.lambda/99.;
			        h_f=h_f+h_db/99/count;
				}
				  
	//			if(j==0)System.out.println(x+"\t"+tf+"\t"+tc+"\t"+twall+"\t"+dTonb+"\t"+h_f+"\t"+dTfdb+"\t"+q_fdb+"\t"+deltaTsub);	
			
			  }
		  }

		  if(debug)System.out.println("dTfdb "+dTfdb+"  Tsat "+tsat+"  q_onb "+q_onb+"  dTOFB "+dTfdb+"  q_ofb "+q_fdb+" Bo "+Bo);
		return NUT_fl;
	  }

	    //Calculs de U vapeur, Corrlation de Colburn
	    public double getUv_(double xc,double xf){
	        double u=1;
	        if((techc!=null)&&(techf!=null)){
	            calcNusseltUv_((Tc_inlet+Tcv)/2., Pc_inlet, xc, mCpcv/mc, false, techc);
	            calcNusseltUv_((Tfs+Tfv)/2., P_fv, xf, mCpfv/mf, false, techf);
	            u=get_U();

		      //  if(debug)System.out.println("techc.Pr vap "+techc.getPrCpx()+"  Cpx "+techc.Cpx+"  techc.lambda "+techc.lambda+"  techc.mu "+techc.mu);
		    //    if(debug)System.out.println("techf.Pr vap "+techf.getPrCpx()+"  Cpx "+techf.Cpx+"  techf.lambda "+techf.lambda+"  techf.mu "+techf.mu);
	           
	        	hvc=Util.aff_d(hc,2);
	        	hvf=Util.aff_d(hf,2);
	            JLabhvc.setText(resIntTh_fr.getString("hvc")+" = "+Util.aff_d(hc,2)+" Re = "+Util.aff_d(techc.Re,2));
	            JLabhvf.setText(resIntTh_fr.getString("hvf")+" = "+Util.aff_d(hf,2)+" Re = "+Util.aff_d(techf.Re,2));
	        }
	        return u;
	    }
		public void calcNusseltUv_(double T, double P, double x, double Cp, 
			    boolean calcDP, TechnoExch te){
				te.initLambdaMu(T, P, x);
			    if(te.mu*te.lambda!=0){
			    	te.calcG();//vitesse massique
			    	te.calcPr(Cp);//nombre de Prandtl Cp en kJ/kg/K
			    	te.calcRe();//nombre de Reynolds
			    	te.Nu=calcNuUv_(T, P, x, te);//le relais est pass  la FlowConfig
//			        double dP=fc.calcDP();
			    	te.calcH();
			    }
			    else{//message : lambda ou mu du fluide inconnu
				    String message="The conductivity or the viscosity is zero for fluid: "+corps.name;
		            message=message+"\nYou should check the corresponding external class";
		            JOptionPane.showMessageDialog(new JFrame(),message);
			    }
			}



		  public double calcNuUv_(double T, double P, double x, TechnoExch te){//Implmentation par dfaut
		        te.initLambdaMu(T, P, x);
				double NUT=0.023*Math.pow(te.getRe(),0.8)*Math.pow(te.getPr(),1./3.);
				if(debug)System.out.println("calcNuTube2 te.Pr vap "+te.getPr()+"  Re "+te.getRe()+"  NUT "+NUT);
			
				return NUT;
		  }
		
			public String saveSpecificParams(){
/*				String hvc=Util.extr_value(JLabhvc.getText(),"hvc");
				String hlvc=Util.extr_value(JLabhlvc.getText(),"hvc");
				String hlc=Util.extr_value(JLabhlc.getText(),"hvc");
				String hvf=Util.extr_value(JLabhvf.getText(),"hvc");
				String hlvf=Util.extr_value(JLabhlvf.getText(),"hvc");
				String hlf=Util.extr_value(JLabhlf.getText(),"hvc");*/
				String h="\tAl="+Util.aff_d(Al)+"\tAlv="+Util.aff_d(Alv)+"\tAv="+Util.aff_d(Av)
	    		+"\thvc="+hvc+"\thlvc="+hlvc+"\thlc="+hlc
	    		+"\thvf="+hvf+"\thlvf="+hlvf+"\thlf="+hlf
	    		+"\tp_dbExp="+A_value.getText();

				return h;
			}
			
			public void readSpecificParams(String ligne_data){
				String value=Util.extr_value2(ligne_data, "Al");
				if(!(value==null))Al=Util.lit_d(value);
		        value=Util.extr_value2(ligne_data, "Alv");
				if(!(value==null))Alv=Util.lit_d(value);
		        value=Util.extr_value2(ligne_data, "Av");
				if(!(value==null))Av=Util.lit_d(value);
		        value=Util.extr_value2(ligne_data, "p_dbExp");
				if(!(value==null))A_value.setText(value);			
			}
			
			public void setNutCorrel(String correlationName){		  
				if(techf.fc instanceof TechnoSteamGeneratorConfigs){
					JPanel1.add(nutCorrelChoice);
					JPanel1.add(nutCorrelLabel);			
				}
				else{
					JPanel1.remove(nutCorrelChoice);
					JPanel1.remove(nutCorrelLabel);			
				}

		    	nutCorrelChoice.setSelectedItem(correlationName);
			}

			public void setPdcCorrel(String correlationName){		    	
				pdcCorrelChoice.setSelectedItem(correlationName);
			}
			

}