/*
Copyright Renaud GICQUEL 2021  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.Vector;


public class TechnoSteamGeneratorConfigs extends FlowConfig 
{
	boolean debug=false;
     public TechnoSteamGeneratorConfigs (){
    }

    public String getCode(){
        return "Boiling";
    }
	public String getClassDescription(){
	    return "TechnoSteamGenerator correlations";
	}
  
    public TechnoSteamGeneratorConfigs (TechnoExch te){
        super(te);
        NuCorrel="evap boiling";
    }
 /*   void setParameterValues(){//modRG 07/2012
        C1=0.022;a_Re=0.79;b_Pr=0.39;c_Visc=0.14;RR=0.001;
        C2=0.31;d_Re=-0.25;    	
    }*/

        
	public double calcNu(double P){
	    if(te.diph){//calcul de Ulv
	    	double xinit=te.amont.X;
	        double Tsat=te.corps.lecorps.getSatTemperature(P,0);
	        double Psat=te.corps.lecorps.getSatPressure(Tsat, 0);
	        te.corps.lecorps.CalcPropCorps(Tsat-0.1, Psat, 0);
	        te.corps.getSubstProperties();
	        double Vl=te.corps.V;
	        Tsat=te.corps.lecorps.getSatTemperature(P,1);
	        Psat=te.corps.lecorps.getSatPressure(Tsat, 1);
	        te.corps.lecorps.CalcPropCorps(Tsat+0.1, Psat, 1);
	        te.corps.getSubstProperties();
	        double Vv=te.corps.V;
	        double fact=Vv/Vl;
	  //  	System.out.println("Vv diph "+Vv+"  Vl "+Vl);
	    	
	 //   	te.aval.getProperties();
	  //  	te.amont.getProperties();
	       //il y a un problme pour les corps externes sur X
	        if(te.corps.lecorps.isMixture) {
		    //	System.out.println("te.aval.X "+te.aval.X+"  xinit "+xinit);
		    //	System.out.println("te.aval.X0 "+te.aval.lecorps.getQuality()[0]+"  te.amont.X0 "+te.amont.lecorps.getQuality()[0]);
		    //	System.out.println("te.aval.corps.X "+te.aval.corps.X+"  te.amont.corps.X "+te.amont.corps.X);
	        	Nu=calcNu(te.aval.X,te.amont.corps.X,fact);//nombre de Nsselt
	        }
	        else  {
		 //   	System.out.println("te.aval.X "+te.aval.X+"  te.amont.X "+te.amont.X);
	        	Nu=calcNu(te.aval.X,te.amont.X,fact);//nombre de Nsselt

	        }
	    //	System.out.println("evapConfig Nu diph "+Nu);
	   // 	System.out.println("Re diph "+te.getRe()+"  Pr "+te.getPr());

	        //prise en compte du taux de vide pour le calcul de la charge en frigorigne
	        calcMeanDensity(Vl, Vv, te.aval.X, te.amont.X);
	    }
	    else Nu=calcNuTube();
	    
	    return Nu;
	}
	
    private double calcNu(double xs, double xe, double fact){//nombre de Nsselt pour un tube
        //xs est le titre de sortie
        //xe est le titre d'entre
        //fact est un paramtre (Vv/Vl pour l'vaporation, PC/Pcond pour la condensation)
        
        double P_calc=te.tHx.P_fl;//P_fl tient compte des pertes de charge singulire et rgulires 
        double T=te.corps.lecorps.getSatTemperature(P_calc, 0);
        te.corps.getSubstProperties();
	    te.corps.lecorps.CalcPropCorps(T+0.1,P_calc,0);
 	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
        double ro_g=1/v;
        te.ro_g=ro_g;
        f=(Double)vProp.elementAt(5);
        double hv=f.doubleValue();
        te.initLambdaMu(T,P_calc, 1);
        double mu_v=te.mu;
        T=te.corps.lecorps.getSatTemperature(P_calc, 0);
 	    te.corps.lecorps.CalcPropCorps(T-0.1,P_calc,0);
	    vProp=te.corps.lecorps.getSubstProperties();
        f=(Double)vProp.elementAt(3);
        v=f.doubleValue();
        double ro_l=1/v;
        double Re=te.getRe();
        te.corps.getSubstProperties();
        f=(Double)vProp.elementAt(5);
        double hl=f.doubleValue();
	    te.corps.lecorps.CalcPropCorps(T-0.2,P_calc,0);
	    vProp=te.corps.lecorps.getSubstProperties();
	    f=(Double)vProp.elementAt(5);
	    double Cpl=(f.doubleValue()-hl)*10;
            
        double Lv=(hv-hl)*1000.;//Latent heat in J/kg
       
        double Bo;//nombre d'bullition
        if(te.tHx.firstIteration)//On utilise cette formule simplifie avant tout calcul
        Bo=Util.lit_d(te.Dh_value.getText())/4./Util.lit_d(te.L_value.getText());
        else Bo=te.tHx.qlv/te.getFlow()*Util.lit_d(te.Ac_value.getText())/Lv;
        if(debug)System.out.println("Bo\t"+Bo+"\tte.tHx.firstIteration\t"+te.tHx.firstIteration);
     
	    te.initLambdaMu(T-0.1,P_calc, 0);
        double mu_l=te.mu;
        double Re_v=Re*mu_l/mu_v;//Reynolds vapeur est recalcul  partir du liquide
        
	    if(false){//si prise en compte laminaire,  reprendre compltement
            double Nu=0;
	        double Nut=C1*Math.pow(turbulentLimit,a_Re)*Math.pow(te.getPr(),b_Pr);
	        double Nul=getNuLamin();
//	        double Re=te.getRe();
	        if(Re<=laminarLimit)Nu=Nul;
	        else if(Re>=turbulentLimit)Nu=C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
	        else{
	            double alpha=(Re-laminarLimit)/(turbulentLimit-laminarLimit);
	            Nu=Nul+(Nut-Nul)*alpha;
	        }
	        
            return 0;//Nu*(F2*(1+3000*Math.pow(Bo,0.86))+F*Math.pow(fact, 0.41));
        }
        else {
	        double Fact=0;
	        //attention : on multiplie Re par (1-x) car dans la corrlation de Gungor et Winterton 
	        //le calcul de Nuliq doit tre fait avec le dbit de la phase liquide seule 
	        if(te.corps.lecorps.isMixture) {
        		te.amont.X=te.amont.corps.X;
	        }
	        double Nut_lo=C1*Math.pow(te.getRe()*(1.-te.amont.X),a_Re)*Math.pow(te.getPr(),b_Pr);
	        
	        double G=te.getFlow()/Util.lit_d(te.Ac_value.getText());
	        double q_wall=Bo*G*Lv;
	        
	        //h pool boiling pour la corrlation de Borishanskiy et al.
	        double h_pb=0.625*(Math.pow(P_calc*1e5,0.14)+8.95e-14*P_calc*1e5*P_calc*1e5)
	        		*Math.pow(q_wall,0.7);
	        
	        //Initialisations pour la corrlation de Saitoh et al.
//			double ys=2*te.getSurfaceTension(T)/9.81/(ro_l-ro_g);
			double ys=2*te.sigma/9.81/(ro_l-ro_g);
			double db=0.51*Math.pow(ys, 0.5);
	        //h pool boiling pour la corrlation de Saitoh et al.
			double h_pbs=207*te.lambda/db*Math.pow(q_wall*db/te.lambda/T, 0.745)*
					Math.pow(ro_g/ro_l, 0.581)*Math.pow(te.getPr(), 0.533);
			double NUT_pbs=h_pbs*Util.lit_d(te.Dh_value.getText())/te.lambda;
			
			//Corrlation de Shah
			double Fr=G*G/9.81/Util.lit_d(te.Dh_value.getText())/ro_l/ro_l;

			
			if(debug)System.out.println("\tq_wall\t"+q_wall+"\tP_calc\t"+P_calc+"\tRe_v\t"+Re_v+"\tRe\t"+Re);
//			System.out.println("q_wall\t"+q_wall+"\th_lo\t"+h_lo+"\th_pb\t"+h_pb+"\tL\t"+Lv);
			if(debug)System.out.println("Bo\t"+Bo+"\tro_l\t"+ro_l+"\tro_g\t"+ro_g+"\tFr\t"+Fr+"\tPr\t"+te.getPr());
			double NUT_BO=0;
			double NUT_GW=0;
			double NUT_Saitoh=0,NUT_KM=0,NUT_K=0;
			double NUT_Shah=0;
			
			//NUT Dittus-Boettler
			double Nu_db=C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
			
			//Initialisations pour la corrlation de Fang
			double M=te.corps.lecorps.M;
			double S_fa=142.5*Math.pow(Bo,0.9)*Math.pow(M,0.55)*Math.pow(ro_l/ro_g,0.33);
//			System.out.println(""+"\tmu_l\t"+mu_l+"\tmu_v\t"+mu_v+"\tlambda\t"+te.lambda+"\tro_l\t"+ro_l+"\tro_g\t"+ro_v+"\tP_calc\t"+P_calc);

	        //Corrlation de Kandlikar
			double f_k=1.58*Math.log(Re)-3.28;
			f_k=1/f_k/f_k;
			//Gnielinski
			double Nu_gni=(Re-1000)*te.getPr()*f_k/2/(1.07+12.7*(Math.pow(te.getPr(), 2./3)-1)*Math.pow(f_k/2, 0.5));

			for(int i=1;i<100;i++){
				double x=i/100.;	
				//NUT et h liquid only
		        Nut_lo=C1*Math.pow(te.getRe()*(1.-x),a_Re)*Math.pow(te.getPr(),b_Pr);
		        double h_lo=Nut_lo/Util.lit_d(te.Dh_value.getText())*te.lambda;
				
		        //Corrlation Gungor et Winterton
				Fact=1+3000*Math.pow(Bo,0.86)+1.12*Math.pow(x/(1-x),0.75)*Math.pow(ro_l/ro_g, 0.41);
				NUT_GW=NUT_GW+Nut_lo*Fact/99.;
				
				
		        //Corrlation de Saitoh et al.
				double Xs;
				if (te.getRe()*(1-x)>=1000)
					Xs=Math.pow(1/x-1, 0.9)*Math.pow(ro_g/ro_l, 0.5)*
						Math.pow(mu_l/mu_v, 0.1);
				else Xs=18.65*Math.pow(Re_v*x, -0.4)*Math.pow(1/x-1, 0.5)*
						Math.pow(ro_g/ro_l, 0.5)*Math.pow(mu_l/mu_v, 0.5);
						
				double We=te.getFlow()/Util.lit_d(te.Ac_value.getText())*x;
//				We=We*We*Util.lit_d(te.Dh_value.getText())/ro_g/te.getSurfaceTension(T);
				We=We*We*Util.lit_d(te.Dh_value.getText())/ro_g/te.sigma;
				double F_s=1+Math.pow(Xs, -1.05)/(1+Math.pow(We, -0.4));
				ys=te.getRe()*(1-x)*Math.pow(F_s, 1.25)*1e-4;
				double S=1/(1+0.4*Math.pow(ys, 1.4));
//				System.out.println("Saitoh "+"\tx\t"+x+"\tF_s\t"+F_s+"\tWe\t"+We+"\tS\t"+S+"\tNut_lo\t"+Nut_lo+"\tNUT_pbs\t"+NUT_pbs);
				NUT_Saitoh=NUT_Saitoh+(F_s*Nut_lo+S*NUT_pbs)/99.;
				
		        //Corrlation de Borishanskiy et al.
		        double h_2=(h_lo*h_lo+0.49*h_pb*h_pb)*
		        		(1+7e-9*h_pb*h_pb/(h_lo*h_lo+0.49*h_pb*h_pb)*
		        		Math.pow(1+x*(ro_l/ro_g-1),1.5)*Math.pow(Bo,-1.5));
		        double h=Math.pow(h_2,0.5);
		        NUT_BO=NUT_BO+h*Util.lit_d(te.Dh_value.getText())/te.lambda/99.;
		        
		        //Corrlation de Shah (1982)
				double Ns;
				double Co=Math.pow(1/x-1, 0.8)*Math.pow(ro_g/ro_l, 0.5);
				Ns=Co;
				if(Fr<0.04)Ns=0.38*Co*Math.pow(Fr, -0.3);
				double Fs=14.7;
				if(Bo<11e-4)Fs=15.43;
				double Fi2=0;
				fact=2.47*Math.pow(Ns, -0.15);
				if(Ns<=0.1)Fi2=Fs*Math.pow(Bo, 0.5)*Math.exp(fact);
				else if((Ns<=1)&&(Ns>=0.1)){
					fact=2.47*Math.pow(Ns, -0.1);
					Fi2=Fs*Math.pow(Bo, 0.5)*Math.exp(fact);
				}
				else if((Ns>1)&&(Bo>=0.3e-4))Fi2=230*Math.pow(Bo, 0.5);
				else Fi2=1+46*Math.pow(Bo, 0.5);
				double Fi_cb=1.8*Math.pow(Ns, -0.8);
				double h_Sh=0;
				if(Fi_cb>Fi2)h_Sh=h_lo*Fi_cb;
				else h_Sh=h_lo*Fi2;

				NUT_Shah=NUT_Shah+h_Sh*Util.lit_d(te.Dh_value.getText())/te.lambda/99.;
//				System.out.println("Shah "+"\tx\t"+x+"\tFi_cb\t"+Fi_cb+"\tWe\t"+We+"\tFi2\t"+Fi2+"\th_lo\t"+h_lo+"\tNUT_Shah\t"+NUT_Shah);
//				dt_wall=dt_wall+q_wall/h_Sh/99.;//selon Shah (dtermine le Delta T wall moyen)

				
				//Corrlation de Kim, S.M. and Mudawar,
				double PhPf=0.98;//rapport du primtre chauff au primtre mouill
				//Nombre de Weber
	//			double We_l=G*G*Util.lit_d(te.Dh_value.getText())/te.getSurfaceTension(T)/ro_l;
				double We_l=G*G*Util.lit_d(te.Dh_value.getText())/te.sigma/ro_l;
							//Nombre de Lockhart-Martinelli
				Xs=Math.pow(1/x-1, 0.9)*Math.pow(ro_g/ro_l, 0.5)*
						Math.pow(mu_l/mu_v, 0.1);
				double h_nb=2345*Math.pow(Bo*PhPf, 0.7)*Math.pow(P_calc/te.corps.lecorps.PC, 0.38)
						*Math.pow(1-x, -0.51);
				double h_cb=5.2*Math.pow(Bo*PhPf, 0.08)*Math.pow(We_l,-0.54)
						+3.5*Math.pow(Xs, -0.94)*Math.pow(ro_g/ro_l, 0.25);
				double Nu_tp=Math.pow(h_nb*h_nb+h_cb*h_cb, 0.5)*Nut_lo;
				NUT_KM=NUT_KM+Nu_tp/99.;
				
		        //Corrlation de Kandlikar
/*				double f_k=1.58*Math.log(Re)-3.28;
				f_k=1/f_k/f_k;
				//Gnielinski
				double Nu_gni=(Re-1000)*Pr*f_k/2/(1.07+12.7*(Math.pow(Pr, 2./3)-1)*Math.pow(f_k/2, 0.5));
//				double h_k=1058*Math.pow(Bo, 0.7)*Nu_gni/dh*lambda;
	*/						
			//	double Co=Math.pow(1/x-1, 0.8)*Math.pow(ro_g/ro_l, 0.5);
				double h_k1=0.6683*Math.pow(Co, -0.2)*Math.pow(1-x, 0.8)
						+1058*Math.pow(Bo, 0.7)*Math.pow(1-x, 0.8);
				h_k1=h_k1*Nu_gni/Util.lit_d(te.Dh_value.getText())*te.lambda;//forme de 2017
			//	h_k1=h_k1*Nu_db/dh*lambda;//forme de 1998
				double h_k2=1.136*Math.pow(Co, -0.9)*Math.pow(1-x, 0.8)
						+667.2*Math.pow(Bo, 0.7)*Math.pow(1-x, 0.8);
				h_k2=h_k2*Nu_gni/Util.lit_d(te.Dh_value.getText())*te.lambda;
		//		h_k2=h_k2*Nu_db/dh*lambda;
				double h_k=h_k1;
				if(h_k2>h_k1)h_k=h_k2;

				NUT_K=NUT_K+h_k*Util.lit_d(te.Dh_value.getText())/te.lambda/99.;
			}
			
			System.out.println("Borishanskiy NUT\t"+NUT_BO+"\tNUT_GW\t"+NUT_GW+"\tNUT_KM\t"+NUT_KM);
			System.out.println("NUT_Saitoh\t"+NUT_Saitoh+"\tNUT_Shah\t"+NUT_Shah+"\tNUT_Kandlikar\t"+NUT_K);

			double Nu;
			if(te.tHx.nutCorrelationName.equals("Borishanskiy & al."))Nu=NUT_BO;
			else if(te.tHx.nutCorrelationName.equals("Saitoh & al."))Nu=NUT_Saitoh;
			else if(te.tHx.nutCorrelationName.equals("Shah"))Nu=NUT_Shah;
			else if(te.tHx.nutCorrelationName.equals("Kim & Mudawar"))Nu=NUT_KM;
			else if(te.tHx.nutCorrelationName.equals("Kandlikar"))Nu=NUT_K;
			
			else Nu=NUT_GW;
						
			System.out.println("correlationName\t"+te.tHx.nutCorrelationName+"\tNUT\t"+Nu);
			return Nu;
	        
        }
     }

	public double calcDP(){
	    return calcDPdiff();
	}

	public double getPressFactor(){
	    return Util.lit_d(te.display_value.getText());
    }

	public void setPressFactor(double fact){
	    te.display_value.setText(Util.aff_d(fact));
    }
/*	public double getSurfaceTension(double T){
		double tau=1-T/647.096;
		double sigma=0.2358*Math.pow(tau, 1.256)*(1-0.625*tau);
		return sigma;
	}
*/
	
	/**
	 * reads specific technoDesign parameters
	 */
	public void readCaract(String ligne_data){
	    super.readCaract(ligne_data);
        String valeur;
        valeur=Util.extr_value2(ligne_data, "pressure_factor");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.display_value.setText(valeur);
        }
        valeur=Util.extr_value2(ligne_data, "flux density");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.tHx.qlv=value;
            te.tHx.firstIteration=false;
        }
        valeur=Util.extr_value2(ligne_data, "eco flux density");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.tHx.ql=value;
        }
     //   te.tHx.init();
	}

	/**
	 * saves specific technoDesign parameters
	 */
    public String saveCaract(){
	    String h=super.saveCaract();
        h=h+"pressure_factor="+te.display_value.getText()+":"
        		+"flux density="+Util.aff_d(te.tHx.qlv)+":"
		+"eco flux density="+Util.aff_d(te.tHx.ql);
        ;
        return h;
    }
	


	

}