/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;
import java.util.*;

/**
 * Classe de dimensionnement technologique d'une turbine
 * Technological design class for turbines
 */

public class TechnoTurb extends TechnoMultiStageTurb
{

	public TechnoTurb(){
	}

	public TechnoTurb(Projet proj, String turbineName, PointThopt amont, PointThopt aval){
		super(proj, turbineName, amont, aval);
	}
	
	public TechnoTurb(Projet proj, String turbineName){
		super(proj, turbineName);
	}

	void setupPanel(){
	    super.setupPanel();
        JPanel1.add(JLabel8);
        JPanel1.add(alphaBaumann_value);
        JPanel1.add(JLabel19);
        JPanel1.add(PVR_value);
        JPanel1.add(outletArea_value);
        JPanel1.add(JLabel1);
        JPanel1.add(JLabel17);
        JPanel1.add(beta_value);
        JPanel1.add(JLabel16);
        JPanel1.add(D_value);
        JPanel1.add(JCheckPVR);
//		JPanel1.add(displayLabel);
//		JPanel1.add(display_value);
	}



    public String getType(){
        return "TechnoTurb";
    }
    public String getCompType(){
        return "TechnoTurb";
    }
	
    public String getClassName(){
        return "TechnoTurb";
    }

	//{{DECLARE_CONTROLS
    //}}
  
    /*
    * Les mthodes ayant pour signature (double P) sont utilises par les algorithmes de recherche de solution
    * lorsque la pression amont de la turbine n'est pas connue
    * Lorsqu'elle l'est, la mthode sans signature est la bonne. Elle fait appel  amont.P
    */
    
    public boolean isPVR(){
        return JCheckPVR.isSelected();
    }
    
    /**
    * renvoie les pertes par vitesse restante
    *<p>
    * returns the residual velocity losses
    * @param volFlow (volumetric flow rate)
    **/
    public double getPVR(double volFlow){
        double PVR=0;
        double A=Util.lit_d(outletArea_value.getText());
        double Vax=volFlow/A;
        double beta=Util.lit_d(beta_value.getText());
        double N=Util.lit_d(N_value.getText());
        double D=Util.lit_d(D_value.getText());
        double U=Math.PI*N*D/60.;
        PVR=Vax*Vax+(Vax/Math.tan(beta/180*Math.PI)-U)*(Vax/Math.tan(beta/180*Math.PI)-U);
        PVR=PVR/2000;
        PVR_value.setText(Util.aff_d(PVR,2));
        return PVR;
    }
    
    /**
    * renvoie le rendement isentropique humide
    *<p>
    * returns the wet isentropic efficiency
    * @param eta_is_sec (dry isentropic efficiency)
    **/
   public double getWetIsentrEfficiency(double eta_is_sec){
        aval.getProperties();
        double titre=aval.X;
       
        corps.lecorps.CalcPropCorps (aval.T-0.1, aval.P, 0);
        Vector vProp=corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(5);
        double hl=f.doubleValue();  
        f=(Double)vProp.elementAt(6);
        double sl=f.doubleValue();
        
        amont.getProperties();
        double Samont=amont.S;
        
        double alphaB=Util.lit_d(alphaBaumann_value.getText());
        
        double L0=(aval.H-hl)/aval.X;
        double Xis=(Samont-sl)/L0*aval.T;
        double DHis=amont.H-hl-L0*Xis;
        double x_final=(amont.H-hl-(1-alphaB)*eta_is_sec*DHis)/(alphaB*DHis*eta_is_sec+L0);
        double eta_is=eta_is_sec-alphaB*(1-x_final);
 //       System.out.println("eta_is sec : \t"+eta_is_sec+"\t eta hum :\t"+eta_is+"\t titre hum :\t"+titre+"\t x_final :\t"+x_final);
	    risentr_value.setText(Util.aff_d(eta_is,4));
        return eta_is;
    }
    
	public void readCompParameters(String ligne_data){
        String valeur;
        super.readCompParameters(ligne_data);
        valeur=Util.extr_value(ligne_data, "outletArea_value");
		if(valeur!=null)outletArea_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "alphaBaumann_value");
        if(valeur!=null)alphaBaumann_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "beta_value");
        if(valeur!=null)beta_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "D_value");
        if(valeur!=null)D_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "isPVR");
        if(valeur!=null)JCheckPVR.setSelected(Util.lit_b(valeur));
	}

	
}
 