/*
Copyright Renaud GICQUEL 2005-2009  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.awt.*;
import java.util.*;

/**
 * Classe pour calculer la pousse spcifique et la consommation spcifique d'un turboracteur
 * 
 * Elle fait appel aux classes Diffuser et Nozzle ainsi qu' la structure d'un turboracteur
 * telle que schmatise dans l'exemple simpleFlux_Ss_post.dia
 *
 * On entre  l'cran le nombre de Mach de l'avion et la pression et la temprature extrieure
 *
 * Le taux de compression est donn en paramtre
 *
 * TurboJetOffDesignDriver2 met  jour les crans de Thermoptim et effectue quelques recalculs avant d'afficher les rsultats
 *
 * Cette classe illustre la manire dont une classe externe peut piloter des reparamtrages 
 * varis d'un projet de structure donne
 *
 * @author Renaud GICQUEL
 */
public class TurboJetOffDesignDriver2 extends ExtPilot implements optimization.Lmdif_fcn,optimization.Lmdif_fcn2, Inversable
{
	boolean isInitialized=false;
	Diffuser diff;
	Nozzle[] nozzle;//array in case one would like to study turbofans (not implemented)
	boolean isBuilt=false;
	String[]composant,nomComposant,nomNozz;
    String combustionChamberName="",compressorName="",nomDiff="",turbineName="",nozzleName="";

    double Ma,Pext,Text,combustionFlow, Kc, Kt, Kn, 
    turbineMassFlow,rotationSpeed,reductionFactor,compressorFlow;
    double comprRatio;
    double[]taux,thrust,conso;
	String tab=new String("\t");
	String ligne=new String("\n");
    
    PointThopt turbUpstream, turbDownstream, comprUpstream, comprDownstream, nozzleDownstream;
    TechnoTurb technoTurbine;
    TechnoGenericTurboCompr technoCompr;
    TechnoNozzle technoNozzle;

	int nfev = 0;
	int njev = 0;
	int nfev2 = 0;
	int njev2 = 0;


	public TurboJetOffDesignDriver2()
	{
		//{{INIT_CONTROLS
		setTitle("airplane thrust");
		getContentPane().setLayout(null);
		setSize(640,579);
		setVisible(false);
		bInitialSettings.setText("Initial settings");
		bInitialSettings.setActionCommand("load");
		getContentPane().add(bInitialSettings);
		bInitialSettings.setBounds(420,12,156,36);
		JLabel1.setText("plane mach number");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(12,32,156,24);
		getContentPane().add(planeMach_value);
		planeMach_value.setBounds(180,32,96,24);
		planeMach_value.setText("0.9");
		planeMach_value.setSelectionColor(new java.awt.Color(204,204,255));
		planeMach_value.setSelectedTextColor(java.awt.Color.black);
		planeMach_value.setCaretColor(java.awt.Color.black);
		planeMach_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel2.setText("ambient pressure (bar)");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(12,68,156,24);
		getContentPane().add(ambientP_value);
		ambientP_value.setBounds(180,68,96,24);
		ambientP_value.setText("0.265");
		ambientP_value.setSelectionColor(new java.awt.Color(204,204,255));
		ambientP_value.setSelectedTextColor(java.awt.Color.black);
		ambientP_value.setCaretColor(java.awt.Color.black);
		ambientP_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel3.setText("ambient temperature (K)");
		getContentPane().add(JLabel3);
		JLabel3.setBounds(12,104,156,24);
		getContentPane().add(ambientT_value);
		ambientT_value.setBounds(180,104,96,24);
		ambientT_value.setText("222.15");
		ambientT_value.setSelectionColor(new java.awt.Color(204,204,255));
		ambientT_value.setSelectedTextColor(java.awt.Color.black);
		ambientT_value.setCaretColor(java.awt.Color.black);
		ambientT_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel4.setText("specific thrust");
		getContentPane().add(JLabel4);
		JLabel4.setForeground(java.awt.Color.red);
		JLabel4.setBounds(12,276,156,24);
		thrust_value.setSelectionColor(new java.awt.Color(204,204,255));
		thrust_value.setSelectedTextColor(java.awt.Color.black);
		thrust_value.setCaretColor(java.awt.Color.black);
		thrust_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(thrust_value);
		thrust_value.setBounds(180,276,96,24);
		fuel_value.setSelectionColor(new java.awt.Color(204,204,255));
		fuel_value.setSelectedTextColor(java.awt.Color.black);
		fuel_value.setCaretColor(java.awt.Color.black);
		fuel_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(fuel_value);
		fuel_value.setBounds(180,312,96,24);
		JLabel5.setText("specific fuel consumption");
		getContentPane().add(JLabel5);
		JLabel5.setForeground(java.awt.Color.red);
		JLabel5.setBounds(12,312,156,24);
		bCalculate.setText("Calculate ");
		bCalculate.setActionCommand("Calculate ");
		getContentPane().add(bCalculate);
		bCalculate.setBounds(384,58,156,40);
		bInitialSettings.setBounds(384,12,156,40);
		JLabel7.setText("Single compression ratio calculation");
		getContentPane().add(JLabel7);
		JLabel7.setForeground(java.awt.Color.blue);
		JLabel7.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel7.setBounds(12,132,553,25);
		JLabel10.setText("Exterior conditions");
		getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel10.setBounds(12,0,553,25);
		Nref_value.setText("10000");
		Nref_value.setSelectionColor(new java.awt.Color(204,204,255));
		Nref_value.setSelectedTextColor(java.awt.Color.black);
		Nref_value.setCaretColor(java.awt.Color.black);
		Nref_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Nref_value);
		Nref_value.setBounds(480,276,96,24);
		JLabel12.setText("Rotation speed (rpm)");
		getContentPane().add(JLabel12);
		JLabel12.setForeground(java.awt.Color.red);
		JLabel12.setBounds(312,276,156,24);
		JLabel13.setText("turbine constant Kt");
		getContentPane().add(JLabel13);
		JLabel13.setBounds(12,168,161,22);
		Kt_value.setText("650");
		Kt_value.setSelectionColor(new java.awt.Color(204,204,255));
		Kt_value.setSelectedTextColor(java.awt.Color.black);
		Kt_value.setCaretColor(java.awt.Color.black);
		Kt_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Kt_value);
		Kt_value.setBounds(180,168,96,23);
		Kc_value.setText("20");
		Kc_value.setSelectionColor(new java.awt.Color(204,204,255));
		Kc_value.setSelectedTextColor(java.awt.Color.black);
		Kc_value.setCaretColor(java.awt.Color.black);
		Kc_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Kc_value);
		Kc_value.setBounds(480,168,96,23);
		JLabel16.setText("turbine inlet temp. (C)");
		getContentPane().add(JLabel16);
		JLabel16.setBounds(312,204,143,16);
		TIT_value.setText("1200");
		TIT_value.setSelectionColor(new java.awt.Color(204,204,255));
		TIT_value.setSelectedTextColor(java.awt.Color.black);
		TIT_value.setCaretColor(java.awt.Color.black);
		TIT_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(TIT_value);
		TIT_value.setBounds(480,204,96,23);
		JLabel15.setText("nozzle constant Kn"); 
		getContentPane().add(JLabel15);
		JLabel15.setBounds(12,204,156,24);
		Kn_value.setText("2400");
		Kn_value.setSelectionColor(new java.awt.Color(204,204,255));
		Kn_value.setSelectedTextColor(java.awt.Color.black);
		Kn_value.setCaretColor(java.awt.Color.black);
		Kn_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Kn_value);
		Kn_value.setBounds(180,204,96,24);
		JLabel17.setText("compressor constant Kc");
		getContentPane().add(JLabel17);
		JLabel17.setBounds(312,168,161,22);
		getContentPane().add(Kc_value);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bInitialSettings.addActionListener(lSymAction);
		bCalculate.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		type="turbojet driver 2";
	}

    /**
    * returns the component type 
    
    public String getType(){
        return type;
    }**/
    
	public String getClassDescription(){
	    return "pilot for a simple flux turbojet project\n\nRequires external classes Nozzle and Diffuser\n\nauthor : R. Gicquel january 2008";
	}
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == TurboJetOffDesignDriver2.this)
			Thrust_WindowClosing(event);
		}
	}

	void Thrust_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JButton bInitialSettings = new javax.swing.JButton();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField planeMach_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField ambientP_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField ambientT_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField thrust_value = new javax.swing.JTextField();
	javax.swing.JTextField fuel_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JButton bCalculate = new javax.swing.JButton();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JTextField Nref_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel13 = new javax.swing.JLabel();
	javax.swing.JTextField Kt_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel16 = new javax.swing.JLabel();
	javax.swing.JTextField TIT_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JTextField Kn_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel17 = new javax.swing.JLabel();
	javax.swing.JTextField Kc_value = new javax.swing.JTextField();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bInitialSettings)
				bInitialSettings_actionPerformed(event);
			else if (object == bCalculate)
				bCalculate_actionPerformed(event);
		}
	}
    

	public void init(){
		isInitialized=true;
		proj=getProjet();
		setupProject();
		//provides the list and type of components in the diagram editor
		String[]listComp=proj.getEditorComponentList();
		composant=new String[listComp.length];
		nomComposant=new String[listComp.length];
		
		//we get names of processes needed
		//i.e. the compressor and the combustion chamber 
        for(int i=0;i<listComp.length;i++){
		    composant[i]=Util.extr_value(listComp[i], "type");
		    nomComposant[i]=Util.extr_value(listComp[i], "name");
		    if(composant[i].equals("Combustion"))combustionChamberName=nomComposant[i];
		    if(composant[i].equals("Compression"))compressorName=nomComposant[i];
		    if(composant[i].equals("Expansion"))turbineName=nomComposant[i];
        }
        
        //consistency test (more precise error messages would be better)
        if((!combustionChamberName.equals(""))&&(!compressorName.equals("")&&(!turbineName.equals("")))&& isBuilt)isBuilt=true;
		if(isBuilt)show();//the driver is opened only if the structure is correct
/*        //initializations for simulation (calculs pour 10 rapports de compression)
        thrust=new double[10];
        conso=new double[10];
        taux=new double[10];
*/        

        comprUpstream=new PointThopt(proj, "1");
        comprDownstream=new PointThopt(proj, "2");
        turbUpstream=new PointThopt(proj, "3");
        turbDownstream=new PointThopt(proj, "4");
        nozzleDownstream=new PointThopt(proj, "5");
        
        compressorName="compressor";
        turbineName="turbine";
        combustionChamberName="combustion chamber";

        technoTurbine= new TechnoTurb(proj, turbineName, turbUpstream, turbDownstream);
        technoTurbine.Kh_value.setText(Kt_value.getText());
	    Kt=Util.lit_d(Kt_value.getText());
        technoTurbine.Kh=Kt; 
	    addTechnoVector(technoTurbine);
	    

	    
        technoCompr= new TechnoGenericTurboCompr(proj, compressorName, comprUpstream, comprDownstream);
        technoCompr.Kc_value.setText(Kc_value.getText());
	    Kc=Util.lit_d(Kc_value.getText());
        technoCompr.Kc=Kc;
	    addTechnoVector(technoCompr);
		
		technoNozzle= new TechnoNozzle(proj, nomNozz[0], turbDownstream, nozzleDownstream);
		technoNozzle.CHOKED_NOZZLE=true;
        technoNozzle.Kh_value.setText(Kn_value.getText());
	    Kn=Util.lit_d(Kn_value.getText());
        technoNozzle.Kh=Kn;
	    addTechnoVector(technoNozzle);

		setupTechnoDesigns(vTechno);
	}
	void bInitialSettings_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
        String[] args=new String[2];
        Vector vProp;
	    if(!compressorName.equals("")){//compressor initialization 
            args=new String[2];
            args[0]="process";
            args[1]=compressorName;
            vProp=proj.getProperties(args);
            String amont=(String)vProp.elementAt(1);
            String aval=(String)vProp.elementAt(2);
            Double f=(Double)vProp.elementAt(3);
            compressorFlow=f.doubleValue();
	    }
        double d=technoCompr.getDiameter(compressorFlow, comprDownstream.P/comprUpstream.P);
        technoCompr.D_value.setText(Util.aff_d(d));
        
	    if(!turbineName.equals("")){//turbine initialization 
            args=new String[2];
            args[0]="process";
            args[1]=turbineName;
            vProp=proj.getProperties(args);
            String amont=(String)vProp.elementAt(1);
            String aval=(String)vProp.elementAt(2);
            Double f=(Double)vProp.elementAt(3);
            turbineMassFlow=f.doubleValue();
            System.out.println("turbineMassFlow: " + turbineMassFlow);
            System.out.println("technoTurbine.getFlow(): " + technoTurbine.getFlow());
            System.out.println("getMassFlow(): " + technoTurbine.getMassFlow());
            System.out.println("technoTurbine.amont.P: " + technoTurbine.amont.P);
            System.out.println("technoTurbine.aval.P: " + technoTurbine.aval.P);
            double tamont=technoTurbine.amont.T-273.15;
            double taval=technoTurbine.aval.T-273.15;
            System.out.println("technoTurbine.amont.T: " + tamont);
            System.out.println("technoTurbine.aval.P: " + technoTurbine.aval.P);
            System.out.println("technoTurbine.aval.T: " + taval);
            System.out.println("technoTurbine.Kh: " + technoTurbine.Kh);
           
        //    technoTurbine.makeDesign();
            Kt=technoTurbine.getStodolaConstant(turbineMassFlow);
            System.out.println("technoTurbine.Kh: " + technoTurbine.Kh);
            Kt_value.setText(Util.aff_d(Kt,4));
            Kn=technoNozzle.getStodolaConstant();
    	    Kn_value.setText(Util.aff_d(Kn,4));
	    }
	    rotationSpeed=Util.lit_d(Nref_value.getText());


	}
    
    void setupProject(){
		//we get names of processes needed
        //in order to access to their different parameters for subsequent calculations
        nozzle=new Nozzle[2];
        nomNozz=new String[2];
        nomNozz[0]="";
        nomNozz[1]="";
        Vector vExt=proj.getExternalClassInstances();//Vector containing the external classes 
        int k=0,j=0;
        for(int i=0;i<vExt.size();i++){
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        ExtProcess ep=(ExtProcess)obj[1];
	        if(ep instanceof Diffuser){
	            diff=(Diffuser)ep;
	            nomDiff=diff.getName();
	            j++;
	        }
	        if(ep instanceof Nozzle){
	            nozzle[k]=(Nozzle)ep;
	            nomNozz[k]=nozzle[k].getName();
	            k++;
	        }
        }
        if(j*k==1)isBuilt=true;//consistency test
  }
	
    
	void bCalculate_actionPerformed(java.awt.event.ActionEvent event){
		calculatePilot();
	}
	public void calculatePilot(){
	    if(!isInitialized)init();//first time initialization
	    
        Pext=Util.lit_d(ambientP_value.getText());//gets the outside pressure (bar)
        Text=Util.lit_d(ambientT_value.getText());//gets the outside temperature (K)
        diff.setAmbientConditions(Text, Pext);//update of the diffuser inlet point 
	    nozzle[0].setExternalPressure(Pext);//update of the nozzle outlet point
        Ma=Util.lit_d(planeMach_value.getText());//gets the plane Mach number
	    double C=diff.getSpeed(Ma, Text, Pext);//update of the diffuser inlet velocity
	    diff.setInletVelocity(C);
	    Kt=Util.lit_d(Kt_value.getText());
        technoTurbine.setKh(Kt);
 //       technoTurbine.Kh_value.setText(Kt_value.getText());
	    Kc=Util.lit_d(Kc_value.getText());
        technoCompr.Kc=Kc;
        technoCompr.Kc_value.setText(Kc_value.getText());
	    technoCompr.N=rotationSpeed; 
	    Kn=Util.lit_d(Kn_value.getText());
        technoNozzle.setKh(Kn);
 //       technoNozzle.Kh_value.setText(Kn_value.getText());
	    
	    turbUpstream.T=Util.lit_d(TIT_value.getText())+273.15;
	    turbUpstream.update(UPDATE_T,!UPDATE_P,!UPDATE_X);
	    turbUpstream.getProperties();
	    
	    turbineMassFlow=technoTurbine.getMassFlow();
        comprUpstream=new PointThopt(proj, "1");
        comprDownstream=new PointThopt(proj, "2");

	    comprRatio=comprDownstream.P/comprUpstream.P;
	    
	    
/*	    
		int m = 1;
		int n = 1;
	        
		double fvec[] = new double[m+1];
		double x[] = new double[n+1];
    	int info[] = new int[2];
		int iflag[] = new int[2];
	        
		x[1] = rotationSpeed;
	
		double residu0;
		double residu1;
	        
        fcn2(m,n,x,fvec,iflag);
		residu0 = optimization.Minpack2_f77.enorm_f77(m,fvec);

		nfev2 = 0;
		njev2 = 0;
		
		double epsi=0.00001;
		optimization.Minpack2_f77.lmdif1_f77(this, m, n, x, fvec, epsi, info);
		residu1 = optimization.Minpack2_f77.enorm_f77(m,fvec);
		
		
		System.out.println(); 
		System.out.println(" Initial L2 norm of the residuals: " + residu0); 
        System.out.println("Final L2 norm of the residuals: " + residu1);
        System.out.println("Number of function evaluations: " + nfev);
        System.out.println("Number of Jacobian evaluations: " + njev);
        System.out.println("Info value: " + info[1]);
        System.out.println("Final approximate solution: " + x[1]);
		System.out.println(); */

		
	    rotationSpeed=Util.dicho_T (this,0,1, "calcNozzleFlow",rotationSpeed*0.95,rotationSpeed*1.1, 3.);
        
    //        technoCompr.makeDesign();
    //        technoNozzle.makeDesign();
	        //calculation of overall engine performance
	        double Cin=diff.getInletVelocity();
	        double Cout0=nozzle[0].getOutletVelocity();
	        double airFlow=technoCompr.getFlow();
	        combustionFlow=airFlow;
	        if(!combustionChamberName.equals("")){
                String[] args=new String[2];
                args[0]="process";
                args[1]=combustionChamberName;
                Vector vProp=proj.getProperties(args);
                Double f=(Double)vProp.elementAt(3);
                combustionFlow=f.doubleValue();
	        }
	        double fAR=combustionFlow/airFlow-1;//fuel air ratio
	        double specThrust=((1+fAR)*Cout0-Cin)/1000;
	        thrust_value.setText(Util.aff_d(specThrust, 3));
	        double specFuelCons=fAR/specThrust;
	        fuel_value.setText(Util.aff_d(specFuelCons, 5));
        System.out.println("combustionFlow "+combustionFlow+" airFlow "+airFlow+" Cin "+Cin+" Cout0 "+Cout0);
	    Nref_value.setText(Util.aff_d(rotationSpeed,2));
	}
	
 	public void fcn(int m, int n, double x[], double fvec[], int iflag[]) {
		
		if (iflag[1]==1) this.nfev++;
		if (iflag[1]==2) this.njev++;
		
		//update of "physical" variables for a better code understanding
        turbineMassFlow=x[1];
        comprRatio=x[2];
       
        //calculation of first residuals
		fvec[1] = turbineInletPressureResidue(turbineMassFlow);
//		fvec[3] =turbineFlowResidue();
		fvec[2] = getComprRatioResidue(compressorFlow);
//		fvec[3] = getNozzleFlow(rotationSpeed);
		getNozzleFlow();
	    turbDownstream.getProperties();
	    turbUpstream.getProperties();

	}
 	double getComprRatioResidue(double flow){
        double ratio=technoCompr.getPressureRatio(flow);
        double res=2*(ratio-comprRatio)/(ratio+comprRatio);//residual
        System.out.println("res comprRatio "+res+" comprRatio "+comprRatio);
        
        return  res;
 
 	}
    
    double turbineInletPressureResidue(double flow){
        double P0=technoTurbine.getTurbineInletPressure(flow);//inversion in P of turbine characteristics knowing flow rate
        double ratio=technoCompr.getPressureRatio(compressorFlow);
        double P=comprUpstream.P*ratio;//compressor outlet pressure given by inversion of equation 4 giving psi as a function of P3/P1
        double res=2*(P-P0)/(P+P0);//residual
        System.out.println("res P turbine "+res+" Kh turb "+technoTurbine.Kh);
      
        return  res;
    }
    
    double turbineFlowResidue(){
    	double flow=technoTurbine.getMassFlow();
    	double res=2*(turbineMassFlow-flow)/(turbineMassFlow+flow);//residual
        System.out.println("res m turbine "+res);
   	return res;
    }
    
    double getNozzleFlow(){ 
            
    	double turbineFlow=technoTurbine.getFlow();
	    compressorFlow=technoCompr.getFlow();
	    reductionFactor=compressorFlow/turbineFlow;
        technoCompr.N_value.setText(Util.aff_d(rotationSpeed));
        System.out.println("turbineFlow "+turbineFlow+ " turbineMassFlow "+turbineMassFlow);
//        rotationSpeed=N;
        technoCompr.N=rotationSpeed;
	    comprUpstream.getProperties();
   //     technoTurbine.makeDesign();
        compressorFlow=turbineMassFlow*reductionFactor;
    	    
	    //flow rates update (in the order of recalculations)
        updateprocess("0", "Exchange",!RECALCULATE,!IS_SET_FLOW, UPDATE_FLOW, compressorFlow, !UPDATE_ETA, 0);
	    diff.tfe.setupFlow(compressorFlow);
        updateprocess(compressorName, "Compression",!RECALCULATE,!IS_SET_FLOW, UPDATE_FLOW, compressorFlow,  !UPDATE_ETA, 1);

        //compressor update and recalculation
 //       comprRatio=technoCompr.getPressureRatio(compressorFlow);//inversion of equation 4 giving psi as a function of P3/P1
	    comprDownstream.P=comprUpstream.P*comprRatio;//compressor outlet point update
	    comprDownstream.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
	    
        double eta_is=technoCompr.getRisentr(compressorFlow);//
        updateprocess(compressorName, "Compression",RECALCULATE,!IS_SET_FLOW,  UPDATE_FLOW, compressorFlow,  UPDATE_ETA, eta_is);
        comprDownstream.getProperties();
	    
/*	    turbUpstream.P=comprDownstream.P;//turbine inlet point update
	    turbUpstream.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
	    turbUpstream.getProperties();*/
        updateprocess(combustionChamberName, "Combustion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, turbineMassFlow, UPDATE_ETA, turbUpstream.T);
        updateprocess(turbineName, "Expansion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, turbineMassFlow,  !UPDATE_ETA, 0);
	    for(int j=0;j<10;j++)proj.calcThopt(); 
	    
	    turbDownstream.getProperties();
	    turbUpstream.getProperties();
       
        double nozzleConstant=technoNozzle.getStodolaConstant(turbineMassFlow);//nozzle characteristics
        
  //      double res=2*(Kn-nozzleConstant)/(Kn+nozzleConstant); 
        double res=Kn-nozzleConstant; 
        System.out.println("res Kn "+res+"  Kn: "+Kn+"  rotationSpeed: "+rotationSpeed);
        return res;
    } 
    
	public void readCompParameters(String ligne_data){
		rotationSpeed=Util.lit_d(Util.extr_value(ligne_data, "rotationSpeed"));
	    Nref_value.setText(Util.aff_d(rotationSpeed,4));
	}
	
    public String saveCompParameters(){
	    String h="rotationSpeed="+Util.aff_d(rotationSpeed)+tab
	    ;
        return h;
    }
    
    void calcTurboJet(){
	     
		int m = 2;
		int n = 2;
	        
		double fvec[] = new double[m+1];
		double x[] = new double[n+1];
    	int info[] = new int[2];
		int iflag[] = new int[2];
	        
		x[1] = turbineMassFlow;
		x[2] = comprRatio;
	    compressorFlow=technoCompr.getFlow();
	
		double residu0;
		double residu1;
	        
        fcn(m,n,x,fvec,iflag);
		residu0 = optimization.Minpack_f77.enorm_f77(m,fvec);

		double epsi=0.0002;//overall precision requested for convergence
        double epsfcn = 1.e-6;//precision for finite differences calculations 
 		
        //modified lmdiff call with specific precision for finite differences calculations
		optimization.Minpack_f77.lmdif2_f77(this, m, n, x, fvec, epsi, epsfcn, info);
		residu1 = optimization.Minpack_f77.enorm_f77(m,fvec);
		
		System.out.println(); 
		System.out.println(" Initial L2 norm of the residuals: " + residu0); 
        System.out.println("Final L2 norm of the residuals: " + residu1);
        System.out.println("Number of function evaluations: " + nfev);
        System.out.println("Number of Jacobian evaluations: " + njev);
        System.out.println("Info value: " + info[1]);
        System.out.println("Final approximate solution: " + x[1] + ", " + x[2] );
		System.out.println(); 
		

    }

 	public void fcn2(int m, int n, double x[], double fvec[], int iflag[]) {
	    if (iflag[1]==1) this.nfev2++;
	    if (iflag[1]==2) this.njev2++;
		rotationSpeed =x[1];
		fvec[1] = getNozzleFlow();
		calcTurboJet();
		
	}

	public double f_dicho(double X, double T,String fonc){
        
        if (fonc.equals("calcNozzleFlow")){
        	rotationSpeed=X;
            technoCompr.N_value.setText(Util.aff_d(X));
            Nref_value.setText(Util.aff_d(X,2));
        	calcTurboJet();
        	double res=getNozzleFlow();
        	thrust_value.setText(Util.aff_d(res, 3));
     
        	return res;
        }
		return 0;
	}
	
}