/*
Copyright Renaud GICQUEL 2018  
renaud.gicquel@s4e2.com

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
/*
 * Ce composant sert  reprsenter un diviseur externe gnrique, lorsque le
 * calcul des branches de sortie est ralis par un pilote, sans qu'il
 * ait besoin d'tre recalcul
 */
package extThopt;

import java.util.*; 

import javax.swing.*;

public class OutletManifold extends ExtDivider implements Inversable
{
    protected static java.util.ResourceBundle resIntTh_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
    

    
    public OutletManifold (){
        super();

 }
    
    public String getType(){
        return "outlet manifold";
    }
    public String getCompType(){
        return getType();
    }

	public String getClassDescription(){
	    return "Generic outlet manifold\n\nauthor : R. Gicquel  march  2018";
	}
    public void init(){
	    getDividerStructure();
        String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=mainProcess;//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        String amont=(String)vProp.elementAt(2);//gets the downstream point name
        getPointProperties(amont);//direct parsing of point property vector
        Double f=(Double)vProp.elementAt(3);
        double flow=f.doubleValue();		//dbit
       
        vTransfo= new Vector[nBranches+1];
        vPoints= new Vector[nBranches+1];
        
        for(int j=0;j<nBranches;j++){
            args[0]="process";//type of the element (see method getProperties(String[] args))
            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
            vProp=proj.getProperties(args);
            String aval=(String)vProp.elementAt(2);//gets the downstream point name
            getPointProperties(aval);//direct parsing of point property vector
            f=(Double)vProp.elementAt(3);
            flow=f.doubleValue();		//dbit
           setupVector(nomBranche[j], aval, j, flow, Tpoint, Ppoint, Xpoint);
       }
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=mainProcess;//name of the process (see method getProperties(String[] args))
        vProp=proj.getProperties(args);
        amont=(String)vProp.elementAt(2);//gets the downstream point name
        getPointProperties(amont);//direct parsing of point property vector
        f=(Double)vProp.elementAt(3);
        flow=f.doubleValue();		//dbit

        setupVector(mainProcess, amont, nBranches, flow, Tpoint, Ppoint, Xpoint);
//	    System.out.println("flow " +flow + " Tpoint " + Tpoint + " Hpoint " + Hpoint);

        updateDivider(vTransfo,vPoints,Tpoint,Hpoint);


    }


	public void calculateProcess(){
	     
	}
	
	
    public double f_dicho(double T, double P, String fonc){
        
        
        return 0;
        
    }

 
}