/*
Copyright Charles Emile HUBERT / Rudolf METKEMEIJER 2005  
Charles.Emile.HUBERT@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import javax.swing.*;

/**
 * classe de couplage du module PEMFC amont
 * 
 * @author CE  HUBERT
*/
             
public class PEMFCentree extends ExtMixer 
{
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField intensite_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField Ncell_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField tauH2_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField tauO2_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField A_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	
    
    double TamontAir, PamontAir, TamontFuel, PamontFuel,T0, Q1;

    String linkProcess,inletFuelProcess,inletAirProcess,inletAirSubstanceName,inletFuelSubstanceName;
    String linkPoint,inletFuelPoint,inletAirPoint;
    
    double[]inletAirFractmol;
    String[]inletAirComp;
    double[]inletFuelFractmol;
    String[]inletFuelComp;
    
    PEMFCsortie outletPEMFC;//module PEMFC aval
    String outletPEMFCName="";
    
    rg.corps.Corps inletAirSubstance;
    rg.corps.Corps inletFuelSubstance;
        
    Vector inputFuelComp,inputAirComp;
    double airFlow,airM,fuelFlow,fuelM,Htot;
    double fractO2,fractN2air,fractH2Oair,fractArAir,fractH2O,fractH2,fractCO2,fractN2,fractCO,fractCH4, fractAr;
    double I, Ncell, tauH2, tauO2, A,tauH2_calc, tauO2_calc;
    
    public PEMFCentree (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,700,150);
		
		
		JLabel1.setText("intensit (A)");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,164,20);
		JPanel1.add(intensite_value);
		intensite_value.setBounds(164,0,40,20);
		intensite_value.setText("80");
		
		JLabel2.setText("nombre de cellules");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,24,164,20);
		JPanel1.add(Ncell_value);
		Ncell_value.setBounds(164,24,40,20);
		Ncell_value.setText("100");
		
		JLabel3.setText("consigne taux utilisation H2");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,164,20);
		JPanel1.add(tauH2_value);
		tauH2_value.setBounds(164,48,40,20);
		tauH2_value.setText("0.7");
		
		JLabel4.setText("consigne taux utilisation O2");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,164,20);
		JPanel1.add(tauO2_value);
		tauO2_value.setBounds(164,72,40,20);
		tauO2_value.setText("0.5");
		
		JLabel5.setText("surface active (cm2)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,96,164,20);
		JPanel1.add(A_value);
		A_value.setBounds(164,96,40,20);
		A_value.setText("0");
		
		JPanel1.add(JLabel6);
		JLabel6.setBounds(204,0,300,20);
		
		JPanel1.add(JLabel7);
		JLabel7.setBounds(204,24,300,20);
		
		JPanel1.add(JLabel8);
		JLabel8.setBounds(204,48,300,20);
		
		JPanel1.add(JLabel9);
		JLabel9.setBounds(204,72,300,20);
		
		//JPanel1.add(JLabel10);
		JLabel10.setBounds(204,96,300,20);
	
		
		type=getType();
		thermoCouplerTypes=new String[0];
		
		
		
		
		/*JLabel1.setText("Intensit =");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,60,20);
		JPanel1.add(intensite);
		intensite.setBounds(60,0,38,20);
		intensite.setText("80");
		*/
		
		/*JPanel1.add(JLabel2);
		JLabel2.setBounds(98,0,300,20);
		
		
		JPanel1.add(JLabel8);
		JLabel8.setBounds(0,24,500,20);
		JPanel1.add(JLabel9);
		JLabel9.setBounds(0,48,500,20);
		JPanel1.add(JLabel10);
		JLabel10.setBounds(0,72,400,20);
		
		*/
				
    }
    
    public void init(){
	    getMixerStructure();
        checkConsistency();
		setupOutletPEMFC();
    }
    
    public String getType(){
        return "PEMFC_entree";
    }
    
	public String getClassDescription(){
	    return "PEMFC fuel cell model\ninlet mixer\nno thermocoupler\n\nauthor : CE. Hubert feb 2004\n\nRef : archive ??";
	}
	public void calculateProcess(){//on vrifie toujours la cohrence
	    getMixerStructure();
        checkConsistency();
        //mais, si outletSOFC existe, le calcul lui est relay
		// if(outletSOFC!=null)outletSOFC.calculateProcess();
	}
    
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        inletFuelProcess="";
        inletAirProcess="";
        Htot=0;
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(me, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String aval=(String)vBranch[j].elementAt(2);//gets the downstream point name
	            getPointProperties(aval);//direct parsing of point property vector
	            lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
                getSubstProperties(nomCorps);
                 String nom=nomCorps;
                if(typeSubst==4){//le corps d'entre est un gaz compos
                    Vector vComp=lecorps.getGasComposition();
					if((Util.contains(vComp,"O2"))){
	                    inletAirProcess=nomBranche[j];
	                    inletAirPoint=aval;
	                }
	                
	                else if((Util.contains(vComp,"H2"))){
	                    inletFuelProcess=nomBranche[j];
	                    inletFuelPoint=aval;
	            	}
               	}
	           
	            else{//le corps d'entre n'est pas un gaz compos
	                String msg = "Error: at least one of the inlet substances is not a mixed gas";
	                JOptionPane.showMessageDialog(me, msg);  
	            }
	        }
	        if((inletAirProcess.equals(""))||(inletFuelProcess.equals(""))){
	            String msg = "PEMin : Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(me, msg);  
	            isBuilt=false;
	        }
        }
        //initialisations relatives  l'air
        args=new String[2];        args[0]="process";
        args[1]=inletAirProcess;
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        airFlow=f.doubleValue();//dbit du gaz  traiter
        String aval=(String)vProp.elementAt(2);
        getPointProperties(aval);
        TamontAir=Tpoint;//temprature d'entre de l'air
        PamontAir=Ppoint;//pression d'entre de l'air
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        
	    inletAirSubstance=lecorps;
	    inletAirSubstanceName=nomCorps;
        
        inputAirComp=lecorps.getGasComposition();//composition du gaz  traiter
        fractO2=Util.molarComp(inputAirComp,"O2");//fraction molaire de O2
        fractN2air=Util.molarComp(inputAirComp,"N2");//fraction molaire de N2
        fractH2Oair=Util.molarComp(inputAirComp,"H2O");//fraction molaire de H2O
        fractArAir=Util.molarComp(inputAirComp,"Ar");//fraction molaire de Ar
          
        airM=Msubst;//masse molaire du gaz  traiter
        Htot=Hsubst*airFlow;
        
        T0=298.15;
        lecorps.CalcPropCorps(T0,PamontAir, 1);
	   	getSubstProperties(nomCorps);
	    double Q1air=Hsubst*airFlow-Htot;
  		//System.out.println("Q1air: "+Q1air);
  
        //chargement du tableau des fractions molaires du gaz  traiter
        Integer i=(Integer)inputAirComp.elementAt(0);
	    int nComp=i.intValue(); 
        inletAirComp= new String[nComp];
        Double[]fracMol= new Double[nComp];
        inletAirFractmol= new double[nComp];
	    inletAirComp=(String[])inputAirComp.elementAt(1);
	    fracMol=(Double[])inputAirComp.elementAt(2);
        for(int j=0;j<nComp;j++){
            inletAirFractmol[j]= fracMol[j].doubleValue();
        }
        
        //initialisations relatives au gaz inletFuel
        args=new String[2];
        args[0]="process";
        args[1]=inletFuelProcess;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(3);
        fuelFlow=f.doubleValue();//dbit du gaz inletFuel (dbit massique)
        aval=(String)vProp.elementAt(2);
        getPointProperties(aval);
        TamontFuel=Tpoint;//temprature d'entre du combustible
        PamontFuel=Ppoint;//pression d'entre du combustible
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        inputFuelComp=lecorps.getGasComposition();//composition du gaz  traiter
        inletFuelSubstance=lecorps;
	    inletFuelSubstanceName=nomCorps;
         
        fuelM=Msubst;//masse molaire du gaz fuel
        Htot=Hsubst*fuelFlow;
         
        lecorps.CalcPropCorps(T0,PamontFuel, 1);
	   	getSubstProperties(nomCorps);
	    double Q1fuel=Hsubst*fuelFlow-Htot;
        //System.out.println("Q1fuel: "+Q1fuel);
        
        Q1 = Q1air+Q1fuel;
        //System.out.println("Q1: "+Q1);
        
        //System.out.println("h_fuel_in??????: "+Hsubst);
        
        fractH2=Util.molarComp(inputFuelComp,"H2");//fraction molaire de H2
        fractCO2=Util.molarComp(inputFuelComp,"CO2");//fraction molaire de CO2
        fractH2O=Util.molarComp(inputFuelComp,"H2O");//fraction molaire de H2O
        fractCH4=Util.molarComp(inputFuelComp,"CH4 ` mthane");//fraction molaire de CH4
        fractN2=Util.molarComp(inputFuelComp,"N2");//fraction molaire de N2
        fractCO=Util.molarComp(inputFuelComp,"CO");//fraction molaire de CO
        fractAr=Util.molarComp(inputFuelComp,"Ar");//fraction molaire de Ar
        
        
        Htot=Htot+fuelFlow*Hpoint;
            
         // System.out.println("Htot cot in??????: "+Htot);
        	        
        I=Util.lit_d(intensite_value.getText());
 		Ncell = Util.lit_d(Ncell_value.getText());;
 		tauH2 = Util.lit_d(tauH2_value.getText());
 		tauO2 = Util.lit_d(tauO2_value.getText());
 		A = Util.lit_d(A_value.getText());
        
        //tauO2 = 0.4348;//rel : 0.434782609
        
        double F_O2_in = airFlow/airM*fractO2;
        double F_H2_in = fuelFlow*fractH2/fuelM;
        double IthMAX=2*96485*fuelFlow*fractH2/fuelM/Ncell;
        double F_O2th=Ncell*I/4/96485;
        double F_H2th=Ncell*I/2/96485;
        tauO2_calc = F_O2th/F_O2_in;
        tauH2_calc = F_H2th/F_H2_in;
        
        
        if(tauO2_calc>(tauO2*1.05)){// si on demande trop d'intensit. Le 1.05 est un marge pour ne pas tre trop embt
			String msg = "Attention : l'intensit demande est trop leve par rapport  la consigne du taux d'utilisation en O2";
	   		JOptionPane.showMessageDialog(me, msg); 
			}
        
        if(tauH2_calc>(tauH2*1.05)){// si on demande trop d'intensit. Le 1.05 est un marge pour ne pas tre trop embt
			String msg = "Attention : l'intensit demande est trop leve par rapport  la consigne du taux d'utilisation en H2";
	   		JOptionPane.showMessageDialog(me, msg); 
			}
        
        //double F_air=F_O2*4.784689*22.415*60;
        //double Q_air=F_O2*4.784689*28.958;
        
        JLabel6.setText("    intensit thorique maximale (F_H2) = "+Util.aff_d(IthMAX,1)+" A");
        JLabel7.setText("    (rarement plus de 150)");
        JLabel8.setText("    taux utilisation H2 rel = "+Util.aff_d(tauH2_calc,3));
        JLabel9.setText("    taux utilisation O2 rel = "+Util.aff_d(tauO2_calc,3));
        JLabel10.setText("   (si = 0 : calcul par dfaut, modle lectrique sinon)");
       // JLabel8.setText("I_th_max(F(H2)) = "+Util.aff_d(IthMAX,1)+" A   ;  F_H2 =  "+Util.aff_d(fuelFlow*fractH2/fuelM,5)+" mol/s");
       // JLabel9.setText("F_O2_cathode_IN = "+Util.aff_d(F_O2_in,4)+" mol/s   ;  consigne taux d'utilisation O2 = "+Util.aff_d(tauO2,4));
        //JLabel9.setText("dbit O2 raction = "+Util.aff_d(F_O2,4)+" mol/s  ;  dbit air sec = "+Util.aff_d(F_air,2)+" NL/min = "+Util.aff_d(Q_air,2)+" g/s");
       // JLabel10.setText("F_O2_raction   =    "+Util.aff_d(F_O2,4)+" mol/s   ;   taux d'utilisation O2 calcul = "+Util.aff_d(tauO2_calc,4));
        //JLabel10.setText("FH2 =  "+Util.aff_d(fuelFlow*fractH2/fuelM,5)+" mol/s ; fraction molaire H2 : "+Util.aff_d(fractH2,4));
        
        //initialisations relatives  la transfo-point de liaison
        linkProcess=mainProcess;
	    args[0]="process";
	    args[1]=linkProcess;
	    Vector vPropMain=proj.getProperties(args);
	    aval=(String)vPropMain.elementAt(2);
	    getPointProperties(aval);
	    linkPoint=aval;
    }
    
 
    public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "intensite_value");
        if(valeur!=null)I=Util.lit_d(valeur);
	    intensite_value.setText(Util.aff_d(I,1));
		double valeurNcell=Util.lit_d(Util.extr_value(ligne_data, "Ncell_value"));
	    Ncell_value.setText(Util.aff_d(valeurNcell,0));
		double valeurtauH2=Util.lit_d(Util.extr_value(ligne_data, "tauH2_value"));
	    tauH2_value.setText(Util.aff_d(valeurtauH2,3));
		double valeurtauO2=Util.lit_d(Util.extr_value(ligne_data, "tauO2_value"));
	    tauO2_value.setText(Util.aff_d(valeurtauO2,3));
		double valeurA=Util.lit_d(Util.extr_value(ligne_data, "A_value"));
	    A_value.setText(Util.aff_d(valeurA,0));
		}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"intensite_value="+intensite_value.getText()+tab
        +"Ncell_value="+Ncell_value.getText()+tab
	    +"tauH2_value="+tauH2_value.getText()+tab
     	+"tauO2_value="+tauO2_value.getText()+tab
	  	+"A_value="+A_value.getText()+tab;
        return h;
  
    }
    
    
    
    
    void setupOutletPEMFC(){
        Vector vExt=proj.getExternalClassInstances();
        for(int i=0;i<vExt.size();i++){
            
           //  System.out.println("vExt.size: "+vExt.size());
             
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        String type=(String)obj[0];
	        if(type.equals("node")){
	            String main=(String)obj[4];
	            String nodeType=(String)obj[3];
	            if((main.equals(linkProcess))&&((nodeType.equals("PEMFC_sortie")))){
	                outletPEMFC=(PEMFCsortie)obj[1];
	                outletPEMFCName=(String)obj[2];
	            }
	        }
        }
    }


}